<?php
/**
 * The template for displaying archive pages
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/
 *
 * @Package Aabbe
 * @since 1.0.0
 * 
 */

get_header();

if ( is_active_sidebar( 'main-sidebar' ) ) {
    $aabbe_layout = 'col-md-8 blog__content__wrap';
}else{
    $aabbe_layout = 'col-md-10 col-md-offset-1 col-lg-10 col-lg-offset-1';
}


?>
<?php 
    if (function_exists('aabbe_title')) {
        aabbe_title();
    }
?>

<div class="content-area section-padding">
    <div class="container">
        
        <?php if ( isset($_GET['author_downloads'] ) && $_GET['author_downloads'] == 'true' ) : ?>
            <?php
            /*
                get_template_part( 'edd/author/author-download-top-meta' );
                Here Will Be Your All FIlter For Search & Query.
            */
            ?>
            <?php 
                $author          = get_user_by( 'id', get_query_var( 'author' ) );
                $author_id       = get_the_author_meta('ID');
                $author_download = get_the_author_meta( 'ID',$author->ID );
                $paged           = ( get_query_var( 'paged')) ? get_query_var( 'paged') : 1;
                $args            = array(
                    'order'          => 'DESC',
                    'post_type'      => 'download',
                    'posts_per_page' => 9,
                    'author'         => $author_download,
                    'paged'          => $paged,
                );

                $temp     = $wp_query; $wp_query = null;
                $wp_query = new WP_Query(); $wp_query->query($args);
            ?>

            <?php  if ( $wp_query->have_posts() ) : ?>

                <div class="row download__grid">
                <?php while ( $wp_query->have_posts() ) : ?>
                    <?php $wp_query->the_post(); ?>
                    <div class="col-md-4 col-lg-4 col-sm-6 col-xs-12">
                        <?php
                            /*
                             * Include the Post-Type-specific template for the content.
                             * If you want to override this in a child theme, then include a file
                             * called content-___.php (where ___ is the Post Type name) and that will be used instead.
                             */
                            get_template_part( 'edd/content/content-download', get_post_format() );
                        ?>
                    </div>
                <?php endwhile; ?>
                </div>

                <?php if ( $wp_query->max_num_pages > 1 ) : ?>
                <div class="row">
                    <div class="col-md-12">
                        <div class="post-pagination">                   
                            <?php aabbe_custom_pagination(); ?>
                        </div>
                    </div>
                </div>
                <?php endif; ?>

            <?php else : ?>

                <div class="row">
                    <div class="col-md-12">
                        <?php get_template_part( 'template-parts/content/content', 'none' ); ?>                            
                    </div>
                </div>

            <?php endif; ?>

        <?php else: ?>

            <div class="row">
                <div class="<?php echo esc_attr( $aabbe_layout ); ?>">

                    <?php 
                        if ( have_posts() ) :
                            while ( have_posts() ) :
                                the_post();

                                /*
                                 * Include the Post-Type-specific template for the content.
                                 * If you want to override this in a child theme, then include a file
                                 * called content-___.php (where ___ is the Post Type name) and that will be used instead.
                                 */
                                get_template_part( 'template-parts/content/content', get_post_format() );

                            endwhile; ?>

                            <div class="page-pagination">                   
                                <?php aabbe_navigation(); ?>
                            </div>
                    <?php
                        else :
                            get_template_part( 'template-parts/content/content', 'none' );
                        endif;
                    ?>

                </div>
                <?php get_sidebar(); ?>

            </div>

        <?php endif; ?>
    </div>
</div>

<?php
get_footer();