<?php
    /**
    * Template Name: EDD User Dashboard
    *
    * This is EDD User Dashboard .
    *
    * @Package Aabbe
    * @since 1.0.0
    * 
    */
    if ( ! defined( 'ABSPATH' ) ) {
    	exit; // Exit if accessed directly.
    }
    get_header();

    global $current_user;

    if (class_exists( 'EDD_Front_End_Submissions' ) ) {
        $user_id = empty( $user_id ) ? get_current_user_id() : $user_id;
        $vendor  = new FES_Vendor( $user_id ,true );
        $user    = wp_get_current_user();
    }
    if ( aabbe_any_data('login_page_logo') != '' ) {
        $login_dashboard_logo = aabbe_any_data( 'login_page_logo');
        $login_dashboard_logo = wp_get_attachment_image_url( $login_dashboard_logo, 'full');
    }else{
        $login_dashboard_logo = AABBE_ROOT_IMAGE . '/default_logo.jpg';
    }
?>
<?php aabbe_title(); ?>
<div class="content-area section-padding">
    <div class="container">
        <div class="row">
        <?php while ( have_posts() ) :
            the_post(); ?>
                <?php if ( is_user_logged_in() ) : ?>
                <div class="col-md-12">
                    <div class="user__dashboard__page">
                        <div class="extended__dasboard__tab__menu">
                            <ul class="nav nav-tabs">
                                <li class="active"><a href="#profile" data-toggle="tab"><?php esc_html_e('Profile','aabbe'); ?></a></li>
                                <li><a href="#purchase" data-toggle="tab"><?php esc_html_e('Purchase History','aabbe'); ?></a></li>
                                <li><a href="#download" data-toggle="tab"><?php esc_html_e('Download History','aabbe'); ?></a></li>
                                <li><a href="#discount" data-toggle="tab"><?php esc_html_e('Discount','aabbe'); ?></a></li>
                                <?php if( class_exists( 'EDD_All_Access' ) ) { ?>
                                <li><a href="#access-pass" data-toggle="tab"><?php esc_html_e('Access Pass','aabbe'); ?></a></li>
                                <?php } ?>
                                <?php if( class_exists( 'EDD_Recurring' ) ) { ?>
                                <li><a href="#subscription" data-toggle="tab"><?php esc_html_e('Subscription','aabbe'); ?></a></li>
                                <?php } ?>
                                <li><a href="<?php echo wp_logout_url(home_url('/')) ?>" class="account__logout"><i class="ti-power-off"></i> <?php esc_html_e( 'Logout', 'aabbe' ); ?></a></li>
                            </ul>
                            <div class="user__dashboard__information">
                                <a href="#" data-toggle="dropdown" class="account__thumb"> <?php echo get_avatar( $user_id,40 ) ?> <?php echo esc_html($current_user->display_name ); ?></a>
                                <a href="<?php echo wp_logout_url(home_url('/')) ?>" class="account__logout"><i class="ti-power-off"></i></a>
                            </div>
                        </div>                    
                        <div class="extended__dashboard__tab__content">
                            <div class="tab-content clearfix">
                                <div class="tab-pane active" id="profile">
                                    <?php echo do_shortcode('[edd_profile_editor]');?>
                                </div>
                                
                                <div class="tab-pane" id="purchase">
                                    <?php echo do_shortcode('[purchase_history]');?>
                                </div>

                                <div class="tab-pane" id="download">
                                    <?php echo do_shortcode('[download_history]');?>
                                </div>

                                <div class="tab-pane" id="discount">
                                    <?php echo do_shortcode('[download_discounts]');?>
                                </div>

                                <?php if( class_exists( 'EDD_All_Access' ) ) { ?>
                                <div class="tab-pane" id="access-pass">
                                    <?php echo do_shortcode('[edd_aa_customer_passes]'); ?>
                                </div>
                                <?php } ?>

                                <?php if( class_exists( 'EDD_Recurring' ) ) { ?>
                                <div class="tab-pane" id="subscription">
                                    <?php echo do_shortcode('[edd_subscriptions]'); ?>
                                </div>
                                <?php } ?>
                            </div>
                        </div>
                    </div>
                </div>
                <?php else: ?>
                <div class="col-md-4 col-xs-12 col-md-offset-4">
                    <div class="aabbe__default__login__form">
                        <div class="login__dashboard__logo">
                            <a href="<?php echo esc_url( home_url( '/' ) ); ?>">
                                <img src="<?php echo esc_url($login_dashboard_logo);  ?>" class="img-responsive login-logo" alt="<?php esc_attr( 'Logo', 'aabbe' ); ?>" />
                            </a>
                        </div>
                        <div class="aabbe__website__login__form">
                            <?php echo do_shortcode('[edd_profile_editor]');?>
                        </div>
                    </div>
                </div>
                <?php endif;?>
        <?php endwhile; // end of the loop. ?>
        </div>
    </div>
</div>
<?php
get_footer(); ?>