<?php
	if ( ! defined( 'ABSPATH' ) ) {
	    exit; // Exit if accessed directly.
	}
	global $post;
	global $edd_logs;
	$author                      = get_user_by( 'id', get_query_var( 'author' ) );
	$author_id                   = get_the_author_meta( 'ID',$author->ID );
	$author_total_product        = count_user_posts($author_id,'download');
	$author_total_download       = edd_count_file_downloads_of_user($author_id );
	$author_total_purchase_count = edd_count_purchases_of_customer( $author_id );
	if ( class_exists('EDD_Front_End_Submissions') ) {
		$vendor                  = new FES_Vendor( $author->ID ,true );
	}
?>
<div class="row flex-v-center">
    <div class="col-md-12 col-lg-12 col-sm-12 col-xs-12">
		<div class="author__top__meta">
		    <div class="author__meta__thumb">
		        <div class="author__name__image">
		            <?php echo get_avatar( $author->ID,140 ) ?>
                	<?php
						if ( class_exists('EDD_Front_End_Submissions') ) :
						$vendor = new FES_Vendor( $author_id ,true );
					?>
						<?php if ('approved' === $vendor->status) : ?>
		                    <div class="author__vendor__accepeted">
		                    	<?php echo '<img src="'.AABBE_ROOT_URI . '/edd/img/check.svg'.'" alt="'.esc_attr__( 'vendor accepted', 'aabbe' ).'">'; ?>
		                    </div>
		                <?php endif; ?>
		            <?php endif; ?>
		        </div>
		    	<div class="autor__top__name__name">
					<div class="author__desc__box">
		                <h3 class="single__author__title">
		                    <?php echo get_the_author_meta( 'display_name',$author->ID );?>
		                </h3>
		                <p class="author__address"><?php echo get_the_author_meta( 'address',$author->ID);?></p>

		                <?php if ( class_exists('EDD_Front_End_Submissions') ) : ?>
		                <div class="bottom__meta__desc hidden">
		                    <p><?php printf( _x( '%s Since', 'FES singular setting for vendor', 'aabbe' ), EDD_FES()->helper->get_vendor_constant_name( $plural = false, $uppercase = true ) ); ?>
		                        <?php echo  date( "d F Y", strtotime( $vendor->date_created ) )?>
		                    </p>
		                </div>

			            <?php
				            if (function_exists('aabbe_product_author_level')) {
				            	echo aabbe_product_author_level();
				            }
			            ?>

		            	<?php endif; ?>
		            </div>
			    </div>
		    </div>
			<div class="author__name__and__details__meta">

				<div class="author__top__details__meta">
					
					<div class="single___author__meta">
						<div class="author__meta__icon"><?php echo '<img src="'.AABBE_ROOT_URI . '/edd/img/box.svg'.'" alt="'.esc_attr__( 'vendor products', 'aabbe' ).'">'; ?></div>
						<div class="author__info__meta">
						    <h4><?php echo esc_html( $author_total_product ); ?></h4>
						    <p><?php esc_html_e('Products','aabbe')?></p>
						</div>
					</div>

					<div class="single___author__meta">
						<div class="author__meta__icon"><?php echo '<img src="'.AABBE_ROOT_URI . '/edd/img/file.svg'.'" alt="'.esc_attr__( 'vendor downloads', 'aabbe' ).'">'; ?></div>
						<div class="author__info__meta">
						    <h4><?php echo esc_html( $author_total_download ); ?></h4>
						    <p><?php esc_html_e('Downloads','aabbe')?></p>
						</div>
					</div>

					<?php if ( class_exists('EDD_Front_End_Submissions') ) : ?>
						<div class="single___author__meta">
					        <div class="author__top__contact">
								<div class="author__tota__review">
					                <div class="author__contact__button">
					                    <a class="text-center" href="#" data-toggle="modal" data-target="#author__message"><?php esc_html_e('Contact','aabbe'); ?></a>
					                </div>
								</div>
					        </div>
						</div>
					<?php endif; ?>
				</div>
		    </div>
		</div>
    </div>
	
</div>

<!-- Author Contact Modal -->
<div class="modal fade author__message__modal" id="author__message" tabindex="-1" role="dialog" aria-labelledby="author__message">
    <div class="modal-dialog" role="document">

    <?php if ( ! is_user_logged_in() ) : ?>
	    <div class="modal-content">
	        <div class="modal-header">
		        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
		        <h4 class="modal-title">Login</h4>
	        </div>
	        <div class="modal-body">
	            <?php echo do_shortcode(' [edd_login]'); ?>
	        </div>
	    </div>

	<?php else:  ?>

        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title"><?php esc_html_e('Contact with this Author','aabbe') ?></h4>
            </div>
            <div class="modal-body">
                <?php 
                    global $post;
                        if ( empty( $author ) ) {                
                            if ( function_exists( 'fes_get_vendor' ) ) {
                                $author = fes_get_vendor();
                            }else{
                                $author = get_user_by( 'slug', get_query_var( 'vendor' ) );                
                                if ( ! $author ) {
                                    $author = get_current_user_id();
                                }
                            }                
                        }                
                    echo do_shortcode( '[fes_vendor_contact_form id=" ' . absint( $author->ID ) . ' "]' );
                ?>
            </div>
        </div>

	<?php endif; ?>
    </div>
</div>