<?php
/**
 * The default template for download page content
 * @Package Aabbe
 *
 */
    if ( ! defined( 'ABSPATH' ) ) {
        exit; // Exit if accessed directly.
    }


    $author    = get_user_by( 'id', get_query_var( 'author' ) );
    $author_id = get_the_author_meta('ID');

    /*-----------------------
        ENABLE OPTION
    ------------------------*/
    global $post;
    $download_id               = get_the_ID();
    $download_cats             = get_the_term_list( get_the_ID(), 'download_category', '', _x(' , ', '', 'aabbe' ), '' );
    $variable_pricing_options  = aabbe_any_data( 'product_variable_pricing_options','custom' );
?>
<?php
    /*-----------------------
        DOWNLOAD COUNT
    ------------------------*/
    global $edd_logs;
    $single_download_count = $edd_logs->get_log_count(get_the_ID(), 'file_download');
    $total_download_count  = $edd_logs->get_log_count('*', 'file_download');
    
    /*-----------------------
        SALE COUNT
    ------------------------*/
    $single_sales_count    = edd_get_download_sales_stats( get_the_ID() );
    $total_sales_count     = $edd_logs->get_log_count('*', 'file_sale');
    $single_sales_count    = $single_sales_count > 1 ? $single_sales_count . '<span class="sale__count__text">'.esc_html__( ' Sales', 'aabbe' ).'</span>'  : $single_sales_count . '<span class="sale__count__text">'.esc_html__( ' Sale', 'aabbe' ).'</span>';
    
    /*-----------------------
        PRICE DETAILS
    ------------------------*/
    $price_amount = edd_get_download_price(get_the_ID());
    $range_price  = edd_price_range( get_the_ID() );

    if ( $price_amount == "0.00" ) {
        $separate_price = esc_html__( 'Free', 'aabbe' );
    }elseif( edd_has_variable_prices(get_the_ID()) ){
        $separate_price = edd_price( get_the_ID(), false );
    }else{
        $separate_price = edd_currency_filter( edd_format_amount( $price_amount ));
    }
    $price_with_decimal = edd_currency_filter($price_amount);

    /*------------------------
        PURCHASE BUTTON
    --------------------------*/
    $default_purchase_button  = edd_get_purchase_link( array( 'download_id' => get_the_ID()) );
    $separate_purchase_button = edd_get_purchase_link( array( 'download_id' => get_the_ID(),'price'=>false ) );
    $separate_variable_button = '<a href="'.get_the_permalink().'" target="_blank" class="price__variable__button">'.esc_html__( 'View Details', 'aabbe' ).'</a>';

    /*-------------------------
        POST UNIQUE SLUG
    --------------------------*/
    $donwload_unique_slug     = get_post( get_the_ID())->post_name;
    /*edd_count_total_file_downloads();edd_get_file_downloaded_count()*/


    /*-------------------------
        PREVIEW URL & GRID STYLE
    --------------------------*/
    $live_demo_url      = get_post_meta( $post->ID, '_preview_url', true );
    $live_preview_text  = aabbe_any_data( 'product_preview_text','Live Preview' );
    $product_grid_style = aabbe_any_data( 'product_grid_style','product_grid_1' );

?>

<article <?php post_class(); ?>>
    <div class="single__donwload__product">
        <?php if ( has_post_thumbnail() ) : ?>
            <div class="download__thumb__gallery">
                

                    <?php if( is_single() ) : ?>
                        <?php the_post_thumbnail('aabbe-edd-preview'); ?>
                        <div class="audio__visualizer" data-url="<?php echo esc_attr( $live_demo_url ); ?>"></div>
                        <button class="audio__play__button" data-action="play"><i class="fa fa-play"></i></button>
                    <?php else : ?>
                        <a href="<?php the_permalink(); ?>">
                            <?php the_post_thumbnail('aabbe-edd-preview'); ?>
                        </a>
                        <div class="audio__preview__wrap">                        
                            <audio class="audio__player audio__content" controls>
                              <source src="<?php echo esc_url( $live_demo_url ); ?>" type="audio/mp3" />
                            </audio>
                        </div>
                    <?php endif; ?>
                
                <?php  if( 'product_grid_2' == $product_grid_style && !is_singular( 'download' ) ) : ?>
                <div class="download__price">
                    <?php echo wp_kses_post( $separate_price ); ?>
                </div>
                <?php endif; ?>

            </div>
        <?php endif; ?>
        
        <?php  if( !is_singular( 'download' ) ) : ?>
        <div class="download__product__details">
            
            <div class="download__top__meta">
                <span class="download__metadata metadata__author"><?php esc_html_e('By ','aabbe'); ?>
                    <?php if ( class_exists( 'EDD_Front_End_Submissions' ) ) : ?>
                        <a href="<?php echo esc_url( aabbe_fes_author_url(get_the_author_meta( 'ID',$author_id )) ); ?>"><?php the_author(); ?></a>
                    <?php else : ?>
                        <a href="<?php echo esc_url(add_query_arg('author_downloads', 'true', get_author_posts_url( get_the_author_meta('ID')))); ?>"><?php the_author(); ?></a>
                    <?php endif; ?>
                </span>
                <?php if( $download_cats ) : ?>
                <span class="download__metadata metadata__category"><?php esc_html_e('In ','aabbe'); ?><?php echo wp_kses_post( $download_cats ); ?></span>
                <?php endif; ?>
            </div>

            <div class="download__price__and__title">
                <?php 
                    if ( get_the_title() ) {
                        if ( is_single() ) {
                            the_title( '<h3 class="single__download__title">', '</h3>' );
                        }else{
                            the_title( '<h3 class="single__download__title"><a href="' . esc_url( get_permalink() ) . '">', '</a></h3>' );
                        }
                    }
                ?>
            </div>
            
            <div class="download__bottom__meta">
                <div class="download__count">
                    <i class="ti-shopping-cart"></i><?php echo wp_kses_post( $single_sales_count ); ?>
                </div>
                <div class="download__review__count">
                    <?php aabbe_edd_rating(true); ?>
                </div>
            </div>
            
        </div>
        <?php endif; ?>

        <?php
            if ( is_single() ) {
                aabbe_link_pages();
            }
        ?>
    </div>
</article>