<?php
    global $post;
    global $current_user;
    $user_id = empty( $user_id ) ? get_current_user_id() : $user_id;
?>

<?php if ( is_user_logged_in() ) : ?>
<div class="extended__dasboard__tab__menu">
    <ul class="nav nav-tabs">
        <li class="active"><a href="#profile" data-toggle="tab"><i class="zil zi-user"></i> <?php esc_html_e('Profile','aabbe'); ?></a></li>
        <li><a href="#purchase" data-toggle="tab"><i class="zil zi-bars"></i> <?php esc_html_e('Purchase History','aabbe'); ?></a></li>
        <li><a href="#download" data-toggle="tab"><i class="zil zi-cube"></i> <?php esc_html_e('Download History','aabbe'); ?></a></li>
        <?php if( class_exists( 'EDD_All_Access' ) ) : ?>
        <li><a href="#access-pass" data-toggle="tab"><i class="zil zi-circle-dot"></i> <?php esc_html_e('Access Pass','aabbe'); ?></a></li>
        <?php endif; ?>
        <?php if( class_exists( 'EDD_Recurring' ) ) : ?>
        <li><a href="#subscription" data-toggle="tab"><i class="zil zi-tag"></i> <?php esc_html_e('Subscription','aabbe'); ?></a></li>
        <?php endif; ?>
        <li><a href="<?php echo wp_logout_url(home_url('/')) ?>" class="account__logout"><i class="ti-power-off"></i> <?php esc_html_e( 'Logout', 'aabbe' ); ?></a></li>
    </ul>
    <div class="user__dashboard__information">
        <a href="#" data-toggle="dropdown" class="account__thumb"> <?php echo get_avatar( $user_id,40 ) ?> <?php echo esc_html($current_user->display_name ); ?></a>
        <a href="<?php echo wp_logout_url(home_url('/')) ?>" class="account__logout"><i class="ti-power-off"></i></a>
    </div>
</div>
<?php endif; ?>

<div class="extended__dashboard__tab__content">
    <div class="tab-content user__dasboard__box clearfix">
        <div class="tab-pane active" id="profile">
            <?php echo do_shortcode('[edd_profile_editor]');?>
        </div>

        <div class="tab-pane" id="purchase">
            <?php echo do_shortcode('[purchase_history]');?>
        </div>

        <div class="tab-pane" id="download">
            <?php echo do_shortcode('[download_history]');?>
        </div>

        <?php if( class_exists( 'EDD_All_Access' ) ) : ?>
        <div class="tab-pane" id="access-pass">
            <?php echo do_shortcode('[edd_aa_customer_passes]'); ?>
        </div>
        <?php endif; ?>

        <?php if( class_exists( 'EDD_Recurring' ) ) : ?>
        <div class="tab-pane" id="subscription">
            <?php echo do_shortcode('[edd_subscriptions]'); ?>
        </div>
        <?php endif; ?>
    </div>
</div>