(function ($) {
    jQuery(document).on('ready', function ($) {
        "use strict";

        /*------------------------------------------------
			EDD REMOVE CART
        -------------------------------------------------*/
        $('.header__cart__widget li.edd-cart-item .edd-remove-from-cart').on('click',function(e){
        	e.preventDefault();
        });

	    var window_width = $(window).width();
	    if ( window_width > 767 ) {
		    /*------------------------------------------------
		        EDD RELATED PRODUCT TOOLTIP
		    -------------------------------------------------*/
		    var tooltip_content = $('.ultimate__toltip__modal');
		    if ( tooltip_content.length > 0 ) {
		        tooltip_content.tooltipster({
		            animation: 'fade',
		            delay: 10,
		            contentAsHTML: true,
		            interactive: false,
		            maxWidth:400,
		            theme:['tooltipster-noir', 'noir-customized'],
		        });
		    }
	    }

	    /*------------------------------------------------
	        EDD RELATED PRODUCT SLIDER
	    -------------------------------------------------*/
	    var relatedPostCarousel = $('.related__download__products');
	    if (relatedPostCarousel.length > 0) {
	        relatedPostCarousel.owlCarousel({
	            merge: true,
	            smartSpeed: 1000,
	            loop: true,
	            nav: true,
	            center: false,
	            dots: false,
	            navText: ['<i class="fa fa-angle-left"></i>', '<i class="fa fa-angle-right"></i>'],
	            autoplay: false,
	            autoplayTimeout: 6000,
	            autoplayHoverPause:true,
	            margin: 10,
	            responsiveClass: true,
	            responsive: {
	                0: {
	                    items: 3
	                },
	                600: {
	                    items: 6
	                },
	                1000: {
	                    items: 6
	                },
	                1200: {
	                    items: 8
	                }
	            }
	        });
	    }

	    /*-------------------------------------------
			VIDEO PLAYER
	    --------------------------------------------*/
		const audio_player = Array.from(document.querySelectorAll('.audio__player')).map(p => new Plyr(p,{
			hideControl:true,
			controls:['play', 'progress', 'current-time', 'mute', 'volume', 'settings']
		}));

		const players = Array.from(document.querySelectorAll('.video__player')).map(p => new Plyr(p,{
			hideControl:true,
			controls:['play-large'],
		}));

		const single_video_player = Array.from(document.querySelectorAll('.video__player__single')).map(p => new Plyr(p,{
			hideControl:true,
		}));

	 	var player = $(".video__media__wrap").hover(hover_video, hide_video);
	    function hover_video(e) {
	        $('video', this).get(0).play();
	    }
	    function hide_video(e) {
	        $('video', this).get(0).pause();
	    }

		var nowPlaying = "none";
		$('.video__player__wrap .plyr__video-wrapper').hover(function(){

			if ( typeof $(this).find('iframe') !== 'undefined' ) {
				nowPlaying = $(this).find('iframe').attr('src');

				if (typeof nowPlaying !== 'undefined') {

					if(nowPlaying.match(/youtube/g) || nowPlaying.match(/youtu.be/g)){

						var main_url = nowPlaying.split("?");
						$(this).find('iframe').attr('src',main_url[0]+'?autoplay=1&mute=1&showinfo=0&' + main_url[1]);

					}else if(nowPlaying.match(/vimeo/g)){

						var controls = '&byline=true&portrait=false&title=true&speed=true&transparent=false&muted=true';
						var main_url = nowPlaying.split("?");
						$(this).find('iframe').attr( 'src',main_url[0]+'?autoplay=true' + controls );
					}
				}
			}

		},function(){
			$(this).find('iframe').attr('src',nowPlaying);
		});


		if ($('.audio__visualizer').length > 0 ) {
			
			/*-----------------------------
				WAVESERVER VISUALIZER
			------------------------------*/
			var wavesurfer;
			var url = $('.audio__visualizer').attr('data-url');
			$(window).on('load',function(){
			    wavesurfer = WaveSurfer.create({
			        container: document.querySelector('.audio__visualizer'),
			        waveColor: '#ffffff',
			        progressColor: '#00b3ff',
			        mediaControls: true
			    });
			    wavesurfer.load(url);
			});

			/*------------------------------
				AUDIO CONTROL
			-------------------------------*/
			$('[data-action="play"]').on('click',function(){
			    wavesurfer.playPause();
			    var cls = $(this).find('i').attr('class');
			    if(cls == 'fa fa-play'){
			    	$(this).find('i').removeClass('fa fa-play');
			    	$(this).find('i').addClass('fa fa-pause');

			    }else{

		            $(this).find('i').removeClass('fa fa-pause');
			    	$(this).find('i').addClass('fa fa-play');
			    }
			});
		}


    }(jQuery));

})(jQuery);