<?php
    /**
     * Template Name: Extended Dashboard ( User & Vendor )
     *
     * Vendor Dashboard
     *
     * @Package Aabbe
     * @since 1.0.0
     * 
     */
    if ( ! defined( 'ABSPATH' ) ) {
    	exit; // Exit if accessed directly.
    } 
    get_header();

    if (class_exists( 'EDD_Front_End_Submissions' ) ) {
        $user_id = empty( $user_id ) ? get_current_user_id() : $user_id;
        $vendor  = new FES_Vendor( $user_id ,true );
        $user    = wp_get_current_user();
    }
    if ( aabbe_any_data('login_page_logo') != '' ) {
        $login_dashboard_logo = aabbe_any_data( 'login_page_logo');
        $login_dashboard_logo = wp_get_attachment_image_url( $login_dashboard_logo, 'full');
    }else{
        $login_dashboard_logo = AABBE_ROOT_IMAGE . '/default_logo.jpg';
    }
?>
<?php aabbe_title(); ?>
<div class="content-area section-padding vendor-dasboard-template-main fes-vendor-dashboard-wrap">

    <?php if ( is_user_logged_in() ) : ?>

        <?php if ( class_exists( 'EDD_Front_End_Submissions' ) ) : ?>
            
            <?php if ( EDD_FES()->vendors->user_is_status( 'approved' )) : ?>

                <div class="container">
                    <div class="row">
                        <div class="col-md-12">
                            <?php echo do_shortcode('[fes_vendor_dashboard]');?>
                        </div>
                    </div>
                </div>

            <?php else : ?>
                <div class="user-extended-dasboard">
                    <div class="container">
                        <div class="row">
                            <div class="col-md-12">
                                <?php get_template_part( 'edd/dashboard/user-dashboard' ); ?>
                            </div>
                        </div>
                    </div>
                </div>
            <?php endif; ?>

        <?php else : ?>

        <div class="user-extended-dasboard">
            <div class="container">
                <div class="row">
                    <div class="col-md-12">
                        <?php get_template_part( 'edd/dashboard/user-dashboard' ); ?>
                    </div>
                </div>
            </div>
        </div>
        <?php endif; ?>

    <?php else : ?>

    <div class="container extended-dashboard-login">
        <div class="row">
            <div class="col-md-4 col-xs-12 col-md-offset-4">
                <div class="aabbe__default__login__form">
                    <div class="login__dashboard__logo">
                        <a href="<?php echo esc_url( home_url( '/' ) ); ?>">
                            <img src="<?php echo esc_url($login_dashboard_logo);  ?>" class="img-responsive login-logo" alt="<?php esc_attr( 'Logo', 'aabbe' ); ?>" />
                        </a>
                    </div>
                    <div class="aabbe__website__login__form">
                        <?php echo do_shortcode('[edd_login]');?>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <?php endif; ?>
</div>
<?php get_footer('blank'); ?>