<?php
    if ( ! defined( 'ABSPATH' ) ) {
        exit; // Exit if accessed directly.
    }
    global $edd_logs;
    $user_id               = empty( $user_id ) ? get_current_user_id() : $user_id;
    $vendor                = new FES_Vendor( $user_id ,true );
    $currentID             = get_the_ID();
    $author                = new WP_User( $post->post_author );
    $single_download_count = $edd_logs->get_log_count( $vendor, 'file_download' );
?>

<div class="vendor-page-title">
    <legend class="aabbe__fes__headers" id="aabbe__dashboard__page__title"><?php esc_html_e( 'Overview', 'aabbe' ); ?></legend>
</div>
<div class="vendor__meta__boxes">
    <div class="single__vendor__meta vendor__meta__earning">
        <h4><?php echo edd_currency_filter( edd_format_amount( $vendor->sales_value ) ); ?></h4>
        <span><?php esc_html_e('Earnings','aabbe');?></span>
    </div>
    <div class="single__vendor__meta vendor__meta__product">
        <h4><?php echo count_user_posts($user_id,'download'); ?></h4>
        <span><?php esc_html_e('Products','aabbe')?></span>
    </div>
    <div class="single__vendor__meta vendor__meta__sales">
        <h4> <?php printf( _n( '%d', '%d', $vendor->sales_count, 'aabbe' ), $vendor->sales_count ); ?></h4>
        <span><?php esc_html_e('Sales','aabbe');?></span>
    </div>
    <div class="single__vendor__meta vendor__meta__download">
        <h4><?php echo esc_html( $single_download_count ); ?></h4>
        <span><?php esc_html_e('Downloads','aabbe');?></span>
    </div>
</div>

<div class="clearfix"></div>
<?php
    $vendor_announcement = EDD_FES()->helper->get_option( 'fes-dashboard-notification', '' );
    if ( $vendor_announcement ) {
    	?>
    	<div id="fes-vendor-announcements">
    	    <h4><?php esc_html_e('Latest Announcement','aabbe');?></h4>
    		<?php echo apply_filters( 'fes_dashboard_content', do_shortcode( $vendor_announcement ) ); ?>
    	</div>
    	<?php
    }
?>
<div id="fes-vendor-store-link">
	<?php echo EDD_FES()->vendors->get_vendor_store_url_dashboard(); ?>
</div>

<div class="fes-comments-wrap">
	<table id="fes-comments-table">
		<tr class="heading_tr">
			<th class="col-author"><?php  esc_html_e( 'Author', 'aabbe' ); ?></th>
			<th class="col-content"><?php  esc_html_e( 'Comment', 'aabbe' ); ?></th>
		</tr>
		<?php echo EDD_FES()->dashboard->render_comments_table( 10 ); ?>
	</table>
</div>