<?php

/*---------------------------------------
	DEFINE FILE FOLDER ROOT
-----------------------------------------*/
define( 'AABBE_ROOT', get_template_directory() );
define( 'AABBE_ROOT_URI', get_template_directory_uri() );
define( 'AABBE_ROOT_IMAGE', AABBE_ROOT_URI .'/assets/img' );
define( 'AABBE_ROOT_CSS', AABBE_ROOT_URI .'/assets/css' );
define( 'AABBE_ROOT_JS', AABBE_ROOT_URI .'/assets/js' );
define( 'AABBE_ROOT_FONTS', AABBE_ROOT_URI .'/assets/fonts' );
define( 'AABBE_ROOT_PLUGINS', AABBE_ROOT_URI .'/plugins' );
 
/*----------------------------------------
	THEME VERSION CONTROL
-----------------------------------------*/
define("AABBE_VERSION", "3.3.0");

/*----------------------------------------
	ADD THEME AFTER SETUP FUNCTIONALITY
-----------------------------------------*/
if (file_exists( AABBE_ROOT . '/inc/setup.php')) {
	require_once( AABBE_ROOT . '/inc/setup.php');
}

/*----------------------------------------
	ADD THEME WIDGET FUNCTIONALITY
-----------------------------------------*/
if (file_exists( AABBE_ROOT . '/inc/widgets.php')) {
	require_once( AABBE_ROOT . '/inc/widgets.php');
}

/*----------------------------------------
 * IMPLEMENT ALL SCRIPTS
-----------------------------------------*/
if (file_exists( AABBE_ROOT . '/inc/scripts.php')) {
	require_once( AABBE_ROOT . '/inc/scripts.php');
}

/*----------------------------------------
 * 	CUSTOM TEMPLATE TAGS FOR THIS THEME.
 ----------------------------------------*/
 if (file_exists( AABBE_ROOT . '/inc/template-tags.php' )) {
 	require_once( AABBE_ROOT . '/inc/template-tags.php' );
 }

/*--------------------------------------
	FUNCTIONS WHICH ENHANCE THE THEME BY HOOKING INTO WORDPRESS.
----------------------------------------*/
if (file_exists( AABBE_ROOT . '/inc/template-functions.php' )) {
	require_once( AABBE_ROOT . '/inc/template-functions.php' );
}

/*--------------------------------------
	BREADCRUMBS
---------------------------------------*/
if (file_exists( AABBE_ROOT . '/inc/breadcrumb.php' )) {
	require_once( AABBE_ROOT . '/inc/breadcrumb.php' );
}

/*--------------------------------------
	FUNCTIONS FOR THEME OPTIONS STYEING.
----------------------------------------*/
if (file_exists( AABBE_ROOT . '/inc/style.php' )) {
	require_once( AABBE_ROOT . '/inc/style.php' );
}

/*--------------------------------------
	CUSTOM FUNCTIONS .
----------------------------------------*/
if (file_exists( AABBE_ROOT .'/inc/custom-functions.php' )) {
	require_once( AABBE_ROOT .'/inc/custom-functions.php' );
}

/*--------------------------------------
	EDD SETUP
----------------------------------------*/
if ( class_exists('Easy_Digital_Downloads') ) {
	require_once( AABBE_ROOT . '/inc/edd.php' );
}
/*--------------------------------------
	CUSTOM NAV WALKER .
----------------------------------------*/
if (file_exists( AABBE_ROOT .'/inc/nav-menu-walker.php' )) {
	require_once( AABBE_ROOT .'/inc/nav-menu-walker.php' );
}
/*--------------------------------------
	THEME OPTON & CUSTOMIZER ADDITIONS.
----------------------------------------*/
if (file_exists( AABBE_ROOT . '/inc/customizer.php')) {
	require_once( AABBE_ROOT . '/inc/customizer.php' );
}

if ( function_exists( 'cs_framework_init' ) && file_exists( AABBE_ROOT . '/lib/metabox-and-theme-option.php' ) ) {
	require_once( AABBE_ROOT . '/lib/metabox-and-theme-option.php' );
}

/*--------------------------------------
	DEMO CONTENT IMPORTER
---------------------------------------*/
if ( defined('FW') && file_exists( AABBE_ROOT . '/inc/importer.php' ) ) {
    require_once( AABBE_ROOT . '/inc/importer.php' );
}

/*--------------------------------------
	REQUIRED PLUGINS.
----------------------------------------*/
if (file_exists( AABBE_ROOT . '/inc/required-plugins.php')) {
	require_once( AABBE_ROOT . '/inc/required-plugins.php' );
}

/*--------------------------------------
	ACF FIELDS
----------------------------------------*/
if (file_exists( AABBE_ROOT . '/lib/acf-fields.php')) {
	require_once( AABBE_ROOT . '/lib/acf-fields.php' );
}