<?php
/*--------------------------
	ACF METABOX CONFIG FILE
----------------------------*/
if( function_exists('acf_add_local_field_group') ):

acf_add_local_field_group(array(
	'key' => 'group_5e72fd969560a',
	'title' => 'Product Details Information',
	'fields' => array(
		array(
			'key' => 'field_5e72fdc0bfe5f',
			'label' => 'Product Thumbnail',
			'name' => '_thumbnail',
			'type' => 'image',
			'instructions' => 'Set a thumbnail ( width : 80px and Height : 80px ). and maximum upload file size is 1MB.',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'return_format' => 'id',
			'preview_size' => 'thumbnail',
			'library' => 'all',
			'min_width' => '',
			'min_height' => '',
			'min_size' => '',
			'max_width' => '',
			'max_height' => '',
			'max_size' => '',
			'mime_types' => 'png,jpg',
		),
		array(
			'key' => 'field_5e72fddfbfe60',
			'label' => 'Preview Url',
			'name' => '_preview_url',
			'type' => 'url',
			'instructions' => 'Set the preview URL for your item so that buyer can see demo.',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'default_value' => '',
			'placeholder' => 'Item Preview Url',
		),
		array(
			'key' => 'field_5e730258e3cc5',
			'label' => 'Product Type',
			'name' => '_file_type',
			'type' => 'text',
			'instructions' => 'Please set your product	type like ( WP, HTML, PSD, LOGO, CODE ).',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'default_value' => '',
			'placeholder' => '',
			'prepend' => '',
			'append' => '',
			'maxlength' => '',
		),
		array(
			'key' => 'field_5e730330418ef',
			'label' => 'Product Version',
			'name' => '_file_version',
			'type' => 'text',
			'instructions' => 'Please set your product current version.',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'default_value' => '',
			'placeholder' => '',
			'prepend' => '',
			'append' => '',
			'maxlength' => '',
		),
		array(
			'key' => 'field_5e73034d418f0',
			'label' => 'Product License Type',
			'name' => '_file_licence',
			'type' => 'text',
			'instructions' => 'Please write here which type license under the release your product ? like ( GPL, CC0, MIT )',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'default_value' => '',
			'placeholder' => '',
			'prepend' => '',
			'append' => '',
			'maxlength' => '',
		),
		array(
			'key' => 'field_5e73036c418f1',
			'label' => 'File Size',
			'name' => '_file_size',
			'type' => 'text',
			'instructions' => 'Please set your product included file size. ( like : 1MB, 2MB etc. )',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'default_value' => '',
			'placeholder' => '',
			'prepend' => '',
			'append' => '',
			'maxlength' => '',
		),
		array(
			'key' => 'field_5e73038d418f2',
			'label' => 'Documentation',
			'name' => '_documentation',
			'type' => 'text',
			'instructions' => 'Documentation File Included ( Yes or No )',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'default_value' => '',
			'placeholder' => '',
			'prepend' => '',
			'append' => '',
			'maxlength' => '',
		),
		array(
			'key' => 'field_5e7303bc418f3',
			'label' => 'Product Compatible With',
			'name' => '_compatible_with',
			'type' => 'text',
			'instructions' => 'Please write here which software version compatible with your product.	( like: Bootstrap, Underscores, Foundation etc. ).',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'default_value' => '',
			'placeholder' => '',
			'prepend' => '',
			'append' => '',
			'maxlength' => '',
		),
		array(
			'key' => 'field_5e7303d5418f4',
			'label' => 'Product Used Framework',
			'name' => '_file_framework',
			'type' => 'text',
			'instructions' => 'Please write here which framework is used to made your product ( like: Bootstrap, Underscores, Foundation etc. ).',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'default_value' => '',
			'placeholder' => '',
			'prepend' => '',
			'append' => '',
			'maxlength' => '',
		),
		array(
			'key' => 'field_5e730404418f5',
			'label' => 'Product Layout',
			'name' => '_file_layout',
			'type' => 'text',
			'instructions' => 'Please select your product layout ( Responsive or Static / Fixed ).',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'default_value' => '',
			'placeholder' => '',
			'prepend' => '',
			'append' => '',
			'maxlength' => '',
		),
		array(
			'key' => 'field_5e730420418f6',
			'label' => 'Product Supported Browser',
			'name' => '_file_supported_browser',
			'type' => 'text',
			'instructions' => 'Please write here which browser are support your product. ex: firefox, chrome, safari.',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'default_value' => '',
			'placeholder' => '',
			'prepend' => '',
			'append' => '',
			'maxlength' => '',
		),
		array(
			'key' => 'field_5e73047e418f7',
			'label' => 'Product Included File',
			'name' => '_file_included',
			'type' => 'text',
			'instructions' => 'Please write here how many file are included in your product package. ( like: html, css, js, psd, eps )',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'default_value' => '',
			'placeholder' => '',
			'prepend' => '',
			'append' => '',
			'maxlength' => '',
		),
	),
	'location' => array(
		array(
			array(
				'param' => 'post_type',
				'operator' => '==',
				'value' => 'download',
			),
		),
	),
	'menu_order' => 0,
	'position' => 'normal',
	'style' => 'default',
	'label_placement' => 'top',
	'instruction_placement' => 'label',
	'hide_on_screen' => '',
	'active' => true,
	'description' => '',
));

acf_add_local_field_group(array(
	'key' => 'group_5e73496f1f61d',
	'title' => 'Set category Icon OR Thumbnail',
	'fields' => array(
		array(
			'key' => 'field_5e8ee6b7a4d84',
			'label' => 'Icon Type',
			'name' => '_icon_type',
			'type' => 'select',
			'instructions' => 'Set the category thumbnail type.',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'choices' => array(
				'image_icon' => 'image_icon',
				'font_icon' => 'font_icon',
			),
			'default_value' => array(
				0 => 'font_icon',
			),
			'allow_null' => 0,
			'multiple' => 0,
			'ui' => 0,
			'return_format' => 'value',
			'ajax' => 0,
			'placeholder' => '',
		),
		array(
			'key' => 'field_5e8ee757a4d85',
			'label' => 'Font Icon',
			'name' => '_category_icon',
			'type' => 'font-awesome',
			'instructions' => 'Set the category thumbnail for specify the product category, image should be max size is 1MB.',
			'required' => 0,
			'conditional_logic' => array(
				array(
					array(
						'field' => 'field_5e8ee6b7a4d84',
						'operator' => '==',
						'value' => 'font_icon',
					),
				),
			),
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'icon_sets' => array(
				0 => 'fas',
				1 => 'far',
				2 => 'fab',
			),
			'custom_icon_set' => '',
			'default_label' => '',
			'default_value' => '',
			'save_format' => 'element',
			'allow_null' => 0,
			'show_preview' => 1,
			'enqueue_fa' => 0,
			'fa_live_preview' => '',
			'choices' => array(
			),
		),
		array(
			'key' => 'field_5e7349bc6b519',
			'label' => 'Image Icon',
			'name' => '_category_thumbnail',
			'type' => 'image',
			'instructions' => 'Set the category thumbnail for specify the product category, image should be max size is 1MB.',
			'required' => 0,
			'conditional_logic' => array(
				array(
					array(
						'field' => 'field_5e8ee6b7a4d84',
						'operator' => '==',
						'value' => 'image_icon',
					),
				),
			),
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'return_format' => 'url',
			'preview_size' => 'thumbnail',
			'library' => 'all',
			'min_width' => '',
			'min_height' => '',
			'min_size' => '',
			'max_width' => 150,
			'max_height' => 150,
			'max_size' => 1,
			'mime_types' => 'jepg, png, jpg, svg',
		),
	),
	'location' => array(
		array(
			array(
				'param' => 'taxonomy',
				'operator' => '==',
				'value' => 'download_category',
			),
		),
	),
	'menu_order' => 0,
	'position' => 'normal',
	'style' => 'default',
	'label_placement' => 'top',
	'instruction_placement' => 'label',
	'hide_on_screen' => '',
	'active' => true,
	'description' => '',
));

endif;

/*-----------------------------
    HIDE ACF FROM DASHBOARD
-------------------------------*/
//add_filter('acf/settings/show_admin', '__return_false');