<?php

define( 'CS_ACTIVE_SHORTCODE', false );
define( 'CS_ACTIVE_TAXONOMY', false );
define( 'CS_ACTIVE_CUSTOMIZE', false );
define( 'CS_ACTIVE_METABOX', true  );
define( 'CS_ACTIVE_FRAMEWORK', true );


/**
 *  CSF METABOX INIT
 */

if ( !function_exists('aabbe_metabox_init') ) {
	function aabbe_metabox_init() {
		CSFramework_Metabox:: instance( array() );
	}
}

add_action( 'init', 'aabbe_metabox_init' );


if ( !function_exists('aabbe_theme_metaboxes') ) {
	/**
	 * [aabbe_theme_metaboxes description]
	 * @param  [type] $metaboxes [get all metaboxes form cs framework]
	 * @return [type]            [new all defined metaboxes array]
	 */
	function aabbe_theme_metaboxes( $metaboxes ) {
		/**
		 * [$options remove pre defined all old metaboxes]
		 * @var array
		 */
		$metaboxes = array();
		/**
		 * 	Add New Metabox In $options array.
		 */

		$metaboxes[]    = array(
			'id'        => '_aabbe_page_metabox',
			'title'     => esc_html__( 'Page Options', 'aabbe' ),
			'post_type' => 'page',
			'context'   => 'normal',
			'priority'  => 'high',
			'sections'  => array(

				// begin section
				array(
					'id'     => 'page_header',
					'type'   => 'group',
					'title'  => esc_html__( 'Page Header Option', 'aabbe' ),
					'name'   => 'page_header_meta',
					'fields' => array(
						array(
							'id'      => 'enable_barner',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Enable Barner', 'aabbe' ),
							'desc'    => esc_html__( 'If you want to show or hide page barner you can set here by toggle ( YES / NO ).', 'aabbe' ),
							'default' => true,
						),
						array(
							'id'         => 'enable_title',
							'type'       => 'switcher',
							'title'      => esc_html__( 'Enable Custom Title', 'aabbe' ),
							'desc'       => esc_html__( 'If you need custom page title you can set here.', 'aabbe' ),
							'default'    => false,
							'dependency' => array( 'enable_barner|enable_barner', '==|==', 'true|true' ),
						),
						array(
							'id'         => 'custom_title',
							'type'       => 'text',
							'title'      => esc_html__( 'Custom Page Title', 'aabbe' ),
							'desc'       => esc_html__( 'Set your preferred custom page title.', 'aabbe' ),
							'dependency' => array( 'enable_title|enable_barner', '==|==', 'true|true' ),
							'default'    => 'Your Title Here',
						),
						array(
							'id'         => 'enable_overlay',
							'type'       => 'switcher',
							'title'      => esc_html__( 'Enable Custom Overlay', 'aabbe' ),
							'default'    => false,
							'dependency' => array( 'enable_barner', '==', 'true' ),
						),
						array(
							'id'      => 'custom_overlay',
							'type'    => 'background',
							'title'   => esc_html__( 'Barner Overlay', 'aabbe' ),
							'desc'    => esc_html__( 'Use a transparen image if you don\'t want use image you can set color', 'aabbe' ),
							'default' => array(
								'image'      => '',
								'repeat'     => 'repeat',
								'position'   => 'center center',
								'attachment' => 'scroll',
								'size'       => '',
								'color'      => '#000c35',
							),
							'dependency' => array( 'enable_overlay|enable_barner', '==|==', 'true|true' ),
						),
						array(
							'id'         => 'overlay_opacity',
							'type'       => 'number',
							'title'      => esc_html__( 'Overlay Opacity', 'aabbe' ),
							'desc'       => esc_html__( 'Please use max value 90 in decimel. and minimum value 0.1', 'aabbe' ),
							'default'    => '70',
							'dependency' => array( 'enable_overlay|enable_barner', '==|==', 'true|true' ),
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Bottom Category Search', 'aabbe' ),
						),
						array(
							'id'      => 'enable_header_category_search',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Enable Header Category Search', 'aabbe' ),
							'desc'    => esc_html__( 'If you want to enable or disable header category search in menu section you can set ( YES / NO )', 'aabbe' ),
							'default' => false,
						),
					),
				),
				// end sections


		    	// begin section
			    array(
					'id'     => 'page_menu',
					'type'   => 'group',
					'title'  => esc_html__( 'Topbar & Main Menu', 'aabbe' ),
					'name'   => 'page_menu_meta',
					'fields' => array(
						array(
							'id'      => 'enable_header_styleing',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Menu Custom Style ?', 'aabbe' ),
							'desc'    => esc_html__( 'If you want to change any header style you can check here it will be appear on this page.', 'aabbe' ),
							'default' => false,
						),
						array(
							'id'      => 'menu_width',
							'type'    => 'select',
							'title'   => esc_html__( 'Menu Container Width', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu with form here you can set ( FULLWIDTH / CONTAINER )', 'aabbe' ),
							'options' => array(
								'container'                 => esc_html__( 'Container', 'aabbe' ),
								'container container__full' => esc_html__( 'Container Full Width', 'aabbe' ),
								'container-fluid'           => esc_html__( 'Full Width', 'aabbe' ),
						  	),
							'default'    => 'container-fluid',
							'dependency' => array( 'enable_header_styleing', '==', 'true' ),
						),
						array(
							'id'      => 'menu_align',
							'type'    => 'select',
							'title'   => esc_html__( 'Menu Text Align', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu text align from here', 'aabbe' ),
							'options' => array(
								'left'   => 'Left',
								'center' => 'Center',
								'right'  => 'Right',
						  	),
							'default'    => 'center',
							'dependency' => array( 'enable_header_styleing', '==', 'true' ),
						),
						array(
							'id'         => 'menu_color',
							'type'       => 'color_picker',
							'title'      => esc_html__( 'Menu Color', 'aabbe' ),
							'desc'       => esc_html__( 'Set the menu color by color picker', 'aabbe' ),
							'default'    => '#ffffff',
							'dependency' => array( 'enable_header_styleing', '==', 'true' ),
						),
						array(
							'id'         => 'menu_hover',
							'type'       => 'color_picker',
							'title'      => esc_html__( 'Menu Hover Color', 'aabbe' ),
							'desc'       => esc_html__( 'Set the menu hover color by color picker', 'aabbe' ),
							'default'    => '#ff5e5e',
							'dependency' => array( 'enable_header_styleing', '==', 'true' ),
						),
						array(
							'id'         => 'menu_sticky_color',
							'type'       => 'color_picker',
							'title'      => esc_html__( 'Menu Sticky Color', 'aabbe' ),
							'desc'       => esc_html__( 'Set the menu sticky color by color picker', 'aabbe' ),
							'default'    => '#00274e',
							'dependency' => array( 'enable_header_styleing', '==', 'true' ),
						),
						array(
							'id'         => 'menu_sticky_hover_color',
							'type'       => 'color_picker',
							'title'      => esc_html__( 'Menu Sticky Hover Color', 'aabbe' ),
							'desc'       => esc_html__( 'Set the menu sticky hover color by color picker', 'aabbe' ),
							'default'    => '#ff5e5e',
							'dependency' => array( 'enable_header_styleing', '==', 'true' ),
						),
						array(
							'id'         => 'menu_dropdown_color',
							'type'       => 'color_picker',
							'title'      => esc_html__( 'Menu Dropdown Color', 'aabbe' ),
							'desc'       => esc_html__( 'Set the menu dropdown color by color picker', 'aabbe' ),
							'default'    => '#00274e',
							'dependency' => array( 'enable_header_styleing', '==', 'true' ),
						),
						array(
							'id'         => 'menu_dropdown_hover_color',
							'type'       => 'color_picker',
							'title'      => esc_html__( 'Menu Dropdown Hover Color', 'aabbe' ),
							'desc'       => esc_html__( 'Set the menu dropdown hover color by color picker', 'aabbe' ),
							'default'    => '#ff5e5e',
							'dependency' => array( 'enable_header_styleing', '==', 'true' ),
						),						
						array(
							'id'         => 'menu_dropdown_hover_background',
							'type'       => 'color_picker',
							'title'      => esc_html__( 'Menu Dropdown Hover Background Color', 'aabbe' ),
							'desc'       => esc_html__( 'Set the menu dropdown background color by color picker', 'aabbe' ),
							'default'    => '#f1fcff',
							'dependency' => array( 'enable_header_styleing', '==', 'true' ),
						),
						array(
							'id'      => 'menu_item_animated_border_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Menu Item Animated Border Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu animated border bottom color by color picker', 'aabbe' ),
							'default' => '#f8f8f8',
							'dependency' => array( 'enable_header_styleing', '==', 'true' ),
						),
					),
			    ),
			    // end sections

		    	// begin section
			    array(
					'id'     => 'page_footer',
					'type'   => 'group',
					'title'  => esc_html__( 'Page Footer Option', 'aabbe' ),
					'name'   => 'page_footer_meta',
					'fields' => array(
					    array(
							'id'      => 'hide_footer',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Hide Footer ?', 'aabbe' ),
							'desc'    => esc_html__( 'If you want do not show the footer you can set here by ( YES / NO ).', 'aabbe' ),
							'default' => false,
					    ),
						array(
							'id'      => 'enable_footer_styleing',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Footer Styleing', 'aabbe' ),
							'desc'    => esc_html__( 'If you need custom style in page footer you can style here.', 'aabbe' ),
							'default' => false,
						),
						array(
							'id'      => 'footer_background',
							'type'    => 'background',
							'title'   => esc_html__( 'Footer Background', 'aabbe' ),
							'desc'    => esc_html__( 'Set the footer backgound color from here and select image. Note: if image and color you can use at a time ( if not found image automatically get the color.)', 'aabbe' ),
							'default' => array(
								'image'      => '',
								'repeat'     => 'repeat',
								'position'   => 'center center',
								'attachment' => 'scroll',
								'size'       => 'cover',
								'color'      => 'rgba(0,0,0,0.01)',
							),
							'dependency' => array( 'enable_footer_styleing', '==', 'true' ),
						),
						array(
							'id'      => 'footer_overlay',
							'type'    => 'background',
							'title'   => esc_html__( 'Footer Background Overlay', 'aabbe' ),
							'desc'    => esc_html__( 'Upload a transparent image or cholse your color t set the footer background overlay', 'aabbe' ),
							'default' => array(
								'image'      => '',
								'repeat'     => 'repeat',
								'position'   => 'center center',
								'attachment' => 'scroll',
								'size'       => '',
								'color'      => 'rgba(0,0,0,0.01)',
							),
							'dependency' => array( 'enable_footer_styleing', '==', 'true' ),
						),
						array(
							'id'         => 'footer_overlay_opacity',
							'type'       => 'number',
							'title'      => esc_html__( 'Overlay Opacity', 'aabbe' ),
							'desc'       => esc_html__( 'Set the background footer background overlay opacity input the max value 90 in decimel.', 'aabbe' ),
							'default'    => '01',
							'dependency' => array( 'enable_footer_styleing', '==', 'true' ),
						),
						array(
							'id'      => 'footer_bottom_bg',
							'type'    => 'background',
							'title'   => esc_html__( 'Footer Bottom Background', 'aabbe' ),
							'desc'    => esc_html__( 'Upload a new background image to set the footer bottom background.', 'aabbe' ),
							'default' => array(
								'image'      => '',
								'repeat'     => 'repeat',
								'position'   => 'center center',
								'attachment' => 'scroll',
								'size'       => '',
								'color'      => 'rgba(0,0,0,0.01)',
							),
							'dependency' => array( 'enable_footer_styleing', '==', 'true' ),
						),
						array(
							'id'         => 'text_color',
							'type'       => 'color_picker',
							'title'      => esc_html__( 'Footer Text Color', 'aabbe' ),
							'desc'       => esc_html__( 'Set footer text color form here.', 'aabbe' ),
							'default'    => 'rgba(0,0,0,0.01)',
							'dependency' => array( 'enable_footer_styleing', '==', 'true' ),
						),
						array(
							'id'         => 'hidding_color',
							'type'       => 'color_picker',
							'title'      => esc_html__( 'Footer Hidding Color', 'aabbe' ),
							'desc'       => esc_html__( 'Set footer footer hidding color form here.', 'aabbe' ),
							'default'    => 'rgba(0,0,0,0.01)',
							'dependency' => array( 'enable_footer_styleing', '==', 'true' ),
						),
						array(
							'id'         => 'a_color',
							'type'       => 'color_picker',
							'title'      => esc_html__( 'Footer links color', 'aabbe' ),
							'desc'       => esc_html__( 'Set the footer area link color', 'aabbe' ),
							'default'    => 'rgba(0,0,0,0.01)',
							'dependency' => array( 'enable_footer_styleing', '==', 'true' ),
						),
						array(
							'id'         => 'a_hover',
							'type'       => 'color_picker',
							'title'      => esc_html__( 'Footer links Hover color', 'aabbe' ),
							'desc'       => esc_html__( 'Set the footer area link hover color', 'aabbe' ),
							'default'    => 'rgba(0,0,0,0.01)',
							'dependency' => array( 'enable_footer_styleing', '==', 'true' ),
						),
					),
			    ),
			    // end sections

		    	// begin section
			    array(
					'id'     => 'page_custom_css',
					'type'   => 'group',
					'title'  => esc_html__( 'Page Custom Css', 'aabbe' ),
					'name'   => 'page_css_meta',
					'fields' => array(
						array(
							'id'      => 'page_cs_css',
							'type'    => 'textarea',
							'title'   => esc_html__( 'Write Custom Css Here', 'aabbe' ),
							'desc'    => esc_html__( 'Write custom css here with css selector.', 'aabbe' ),
							'default' => '',
						),
					),
			    ),
			    // end sections
		    ),
		);

		return $metaboxes;
	}
}

add_filter( 'cs_metabox_options', 'aabbe_theme_metaboxes' );


/**
 *  CSF OPTION PANEL INIT
 */

if ( !function_exists('aabbe_theme_options_init') ) {
	function aabbe_theme_options_init(){
		$settings           = array(
		  'menu_title'      => esc_html__('Aabbe Options','aabbe'),
		  'menu_type'       => 'menu',
		  'menu_parent'     => 'themes.php',
		  'menu_slug'       => 'aabbe-options',
		  'ajax_save'       => true,
		  'show_reset_all'  => true,
		  'framework_title' => esc_html__('Aabbe WordPress Theme','aabbe').'<small>'.esc_html__( ' By QuomodoTheme', 'aabbe' ).'</small>',
		  'menu_icon'       => 'dashicons-admin-generic',
		  'menu_position'   => 2
		);
		CSFramework:: instance( $settings, array() );
	}
}

add_action('init','aabbe_theme_options_init');

if ( !function_exists('aabbe_theme_option_panel') ) {

	/**
	 * [aabbe_theme_option_panel description]
	 * @param  [type] $options [get all option form cs framework]
	 * @return [array]          [new all defined options array]
	 */
	function aabbe_theme_option_panel( $options ) {
		/**
		 * [$options remove pre defined all old options]
		 * @var array
		 */
		$options = array();
		/**
		 * 	Add New Option In $options array.
		 */

		/* HEADER */
		$options[]   = array(
			'name'     => 'header_section',
			'title'    => esc_html__( 'Header Section', 'aabbe' ),
			'icon'     => 'fa fa-home',
			'sections' => array(

			    // sub section
			    array(
					'name'   => 'theme_header_style',
					'title'  => esc_html__( 'Header Style', 'aabbe' ),
					'icon'   => 'fa fa-credit-card',
					'fields' => array(
						array(
							'id'      => 'enable_header_style',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Enable Header Style', 'aabbe' ),
							'desc'    => esc_html__( 'If you want to enable or disable header style you can set ( YES / NO )', 'aabbe' ),
							'default' => false,
						),
						array(
							'id'      => 'header_style',
							'type'    => 'image_select',
							'title'   => esc_html__( 'Header Style', 'aabbe' ),
							'desc'    => esc_html__( 'Select the header style which you want to show on your website.', 'aabbe' ),
							'options' => array(
								'header-1' => AABBE_ROOT_IMAGE . '/header/header_1.png',
								'header-9' => AABBE_ROOT_IMAGE . '/header/header_1.png',
							),
							'default' => 'header-1',
						),
					),
				),

			    // sub section
			    array(
					'name'   => 'top_bar',
					'title'  => esc_html__( 'Top Bar', 'aabbe' ),
					'icon'   => 'fa fa-bars',
					'fields' => array(
						array(
							'id'      => 'enable_topbar',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Enable Topbar', 'aabbe' ),
							'desc'    => esc_html__( 'If you want to enable or disable topbar you can set ( YES / NO )', 'aabbe' ),
							'default' => false,
						),
						array(
							'id'         => 'phone_number',
							'type'       => 'text',
							'title'      => esc_html__( 'Phone Number', 'aabbe' ),
							'desc'       => esc_html__( 'Set the topbar contact phone number.', 'aabbe' ),
							'default'    => '+8801744430440',
							'dependency' => array( 'enable_topbar', '==', 'true' ),
						),
						array(
							'id'         => 'email_address',
							'type'       => 'text',
							'title'      => esc_html__( 'Email Address', 'aabbe' ),
							'desc'       => esc_html__( 'Set the topbar contact email address.', 'aabbe' ),
							'default'    => 'mehedidb@gmail.com',
							'dependency' => array( 'enable_topbar', '==', 'true' ),
						),
						array(
							'id'         => 'enable_social',
							'type'       => 'switcher',
							'title'      => esc_html__( 'Enable Social', 'aabbe' ),
							'desc'       => esc_html__( 'If you want to enable or disable top bar social profile you can set ( YES / NO )', 'aabbe' ),
							'default'    => false,
							'dependency' => array( 'enable_topbar', '==', 'true' ),
						),
					),
				),

			    // sub section
			    array(
					'name'   => 'mainmenu',
					'title'  => esc_html__( 'Main Menu', 'aabbe' ),
					'icon'   => 'fa fa-sitemap',
					'fields' => array(
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'One Page Navigation Setting', 'aabbe' ),
						),
						array(
							'id'      => 'one_page_navigation',
							'type'    => 'switcher',
							'title'   => esc_html__( 'One Page Navigaton On ?', 'aabbe' ),
							'desc'    => esc_html__( 'If you want to enable or disable one page menu link effect it will be effect inside the page (#) links.', 'aabbe' ),
							'default' => false,
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Menu Sticky', 'aabbe' ),
						),
						array(
							'id'      => 'sticky_menu',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Sticky Menu ?', 'aabbe' ),
							'desc'    => esc_html__( 'If you want to enable or disable menu sticky in header section you can set ( YES / NO )', 'aabbe' ),
							'default' => true,
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Menu Action Buttons', 'aabbe' ),
						),
						array(
							'id'      => 'enable_search',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Enable Search Button', 'aabbe' ),
							'desc'    => esc_html__( 'If you want to enable or disable search button in menu section you can set ( YES / NO )', 'aabbe' ),
							'default' => false,
						),
						array(
							'id'      => 'enable_offcanvas',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Enable OffCanvas Sidebar Button', 'aabbe' ),
							'desc'    => esc_html__( 'If you want to enable or disable offcanvas button in menu section you can set ( YES / NO )', 'aabbe' ),
							'default' => false,
						),
						array(
							'id'      => 'enable_cart_bubtton',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Enable Curt Button', 'aabbe' ),
							'desc'    => esc_html__( 'If you want to enable or disable cart button in menu section you can set ( YES / NO )', 'aabbe' ),
							'default' => false,
						),
						array(
							'id'      => 'enable_promo_menu',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Enable Promo Menu Button', 'aabbe' ),
							'desc'    => esc_html__( 'If you want to enable or disable pro menu button in menu section you can set ( YES / NO )', 'aabbe' ),
							'default' => false,
						),
						array(
							'id'      => 'enable_user_menu',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Enable User Menu Button', 'aabbe' ),
							'desc'    => esc_html__( 'If you want to enable or disable user menu button in menu section you can set ( YES / NO )', 'aabbe' ),
							'default' => false,
						),
						array(
							'id'      => 'enable_language_bubtton',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Enable Language Button', 'aabbe' ),
							'desc'    => esc_html__( 'If you want to enable or disable Language button in menu section you can set ( YES / NO )', 'aabbe' ),
							'default' => false,
						),
						array(
							'id'      => 'enable_action',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Enable Action Button', 'aabbe' ),
							'desc'    => esc_html__( 'If you want to enable or disable action button in menu section you can set ( YES / NO )', 'aabbe' ),
							'default' => false,
						),
						array(
							'id'         => 'button_text',
							'type'       => 'text',
							'title'      => esc_html__( 'Button Text', 'aabbe' ),
							'desc'       => esc_html__( 'Set the button text here', 'aabbe' ),
							'dependency' => array( 'enable_action', '==', 'true' ),
							'default'    => 'Sign Up',
						),
						array(
							'id'         => 'button_url',
							'type'       => 'text',
							'title'      => esc_html__( 'Button Link', 'aabbe' ),
							'desc'       => esc_html__( 'Set the button link here', 'aabbe' ),
							'dependency' => array( 'enable_action', '==', 'true' ),
							'default'    => 'https://facebook.com/mehedidb',
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Menu Width & Align', 'aabbe' ),
						),
						array(
							'id'      => 'menu_width',
							'type'    => 'select',
							'title'   => esc_html__( 'Menu Container Width', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu with form here you can set ( FULLWIDTH / CONTAINER )', 'aabbe' ),
							'options' => array(
								'container'                 => esc_html__( 'Container', 'aabbe' ),
								'container container__full' => esc_html__( 'Container Full Width', 'aabbe' ),
								'container-fluid'           => esc_html__( 'Full Width', 'aabbe' ),
						  	),
							'default' => 'container container__full',
						),
						array(
							'id'      => 'menu_align',
							'type'    => 'select',
							'title'   => esc_html__( 'Menu Text Align', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu text align from here', 'aabbe' ),
							'options' => array(
								'left'   => 'Left',
								'center' => 'Center',
								'right'  => 'Right',
						  	),
							'default' => 'center',
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Menu Background', 'aabbe' ),
						),
						array(
							'id'      => 'menu_bg',
							'type'    => 'background',
							'title'   => esc_html__( 'Menu Background', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu background form here.', 'aabbe' ),
							'default' => array(
								'image'      => '',
								'repeat'     => 'repeat',
								'position'   => 'center center',
								'attachment' => 'scroll',
								'size'       => '',
								'color'      => '#ffffff',
							),
						),
						array(
							'id'      => 'bg_opacity',
							'type'    => 'number',
							'title'   => esc_html__( 'Background Opacity', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu background opacity here use max value 99 and minimux value 1 in decimel.', 'aabbe' ),
							'default' => '01',
						),
						array(
							'id'      => 'sticky_bg',
							'type'    => 'background',
							'title'   => esc_html__( 'Menu Sticky Background', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu sticky background form here.', 'aabbe' ),
							'default' => array(
								'image'      => '',
								'repeat'     => 'repeat',
								'position'   => 'center center',
								'attachment' => 'scroll',
								'size'       => '',
								'color'      => '#ffffff',
							),
						),
						array(
							'id'      => 'sticky_bg_opacity',
							'type'    => 'number',
							'title'   => esc_html__( 'Sticky Background Opacity', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu sticky background opacity here use max value 99 and minimux value 1 in decimel.', 'aabbe' ),
							'default' => '99',
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Menu Color', 'aabbe' ),
						),
						array(
							'id'      => 'menu_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Menu Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu color by color picker', 'aabbe' ),
							'default' => '#ffffff',
						),
						array(
							'id'      => 'menu_hover',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Menu Hover Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu hover color by color picker', 'aabbe' ),
							'default' => '#ff5e5e',
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Menu Sticky Color', 'aabbe' ),
						),
						array(
							'id'      => 'menu_sticky_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Menu Sticky Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu sticky color by color picker', 'aabbe' ),
							'default' => '#00274e',
						),
						array(
							'id'      => 'menu_sticky_hover_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Menu Sticky Hover Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu sticky hover color by color picker', 'aabbe' ),
							'default' => '#ff5e5e',
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Menu Dropdown Color & Hover', 'aabbe' ),
						),
						array(
							'id'      => 'menu_dropdown_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Menu Dropdown Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu dropdown color by color picker', 'aabbe' ),
							'default' => '#00274e',
						),
						array(
							'id'      => 'menu_dropdown_hover_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Menu Dropdown Hover Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu dropdown hover color by color picker', 'aabbe' ),
							'default' => '#ff5e5e',
						),						
						array(
							'id'      => 'menu_dropdown_hover_background',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Menu Dropdown Hover Background Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the dropdown background color by color picker', 'aabbe' ),
							'default' => '#f1fcff',
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Menu Item Animated Border', 'aabbe' ),
						),
						array(
							'id'      => 'menu_item_animated_border_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Menu Item Animated Border Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu animated border bottom color by color picker', 'aabbe' ),
							'default' => '#f8f8f8',
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Menu Border', 'aabbe' ),
						),
						array(
							'id'      => 'menu_border_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Menu Border Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu border bottom color by color picker', 'aabbe' ),
							'default' => 'rgba(255,255,255,.15)',
						),
					),
				),


				// sub section 1
				array(
					'name'   => 'mobile_menu',
					'title'  => esc_html__( 'Mobile Menu', 'aabbe' ),
					'icon'   => 'fa fa-mobile',
					'fields' => array(
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Mobile Menu Type & Menu Buttons', 'aabbe' ),
						),
						array(
							'id'      => 'mobile_menu_style',
							'type'    => 'select',
							'title'   => esc_html__( 'Mobile Menu Style', 'aabbe' ),
							'desc'    => esc_html__( 'Set the mobile menu style form here.', 'aabbe' ),
							'options' => array(
								'static' => esc_html__( 'Menu Postion Top', 'aabbe' ),
								'left'   => esc_html__( 'Menu Postion Left', 'aabbe' ),
								'right'  => esc_html__( 'Menu Postion Right', 'aabbe' ),
						  	),
							'default' => 'center',
						),
						array(
							'id'         => 'contact_number',
							'type'       => 'text',
							'title'      => esc_html__( 'Contact Phone', 'aabbe' ),
							'desc'       => esc_html__( 'Set the mobile menu contact phone no.', 'aabbe' ),
							'default'    => '+8801744430440',
							'dependency' => array( 'mobile_menu_style', 'any', 'left,right' ),
						),
						array(
							'id'         => 'contact_location',
							'type'       => 'text',
							'title'      => esc_html__( 'Contact Link', 'aabbe' ),
							'desc'       => esc_html__( 'Set the mobile menu contact link here.', 'aabbe' ),
							'default'    => 'http://themeforest.net/user/quomodothemes',
							'dependency' => array( 'mobile_menu_style', 'any', 'left,right' ),
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Mobile Menu Background', 'aabbe' ),
						),
						array(
							'id'      => 'mobile_menu_bg',
							'type'    => 'background',
							'title'   => esc_html__( 'Menu Background', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu background form here.', 'aabbe' ),
							'default' => array(
								'image'      => '',
								'repeat'     => 'repeat',
								'position'   => 'center center',
								'attachment' => 'scroll',
								'size'       => '',
								'color'      => '#ffffff',
							),
						),
						array(
							'id'      => 'mobile_bg_opacity',
							'type'    => 'number',
							'title'   => esc_html__( 'Background Opacity', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu background opacity here use max value 99 and minimux value 1 in decimel.', 'aabbe' ),
							'default' => '99',
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Mobile Menu Sticky Background', 'aabbe' ),
						),
						array(
							'id'      => 'mobile_sticky_bg',
							'type'    => 'background',
							'title'   => esc_html__( 'Menu Sticky Background', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu sticky background form here.', 'aabbe' ),
							'default' => array(
								'image'      => '',
								'repeat'     => 'repeat',
								'position'   => 'center center',
								'attachment' => 'scroll',
								'size'       => '',
								'color'      => '#ffffff',
							),
						),
						array(
							'id'      => 'mobile_sticky_bg_opacity',
							'type'    => 'number',
							'title'   => esc_html__( 'Sticky Background Opacity', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu sticky background opacity here use max value 99 and minimux value 1 in decimel.', 'aabbe' ),
							'default' => '99',
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Mobile Menu Color', 'aabbe' ),
						),
						array(
							'id'      => 'mobile_menu_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Menu Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu color by color picker', 'aabbe' ),
							'default' => '#00274e',
						),
						array(
							'id'      => 'mobile_menu_hover',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Menu Active & Hover Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu item active &hover color by color picker', 'aabbe' ),
							'default' => '#ff5e5e',
						),
						array(
							'id'      => 'mobile_menu_hover_background',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Menu Active Background Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu active background color by color picker', 'aabbe' ),
							'default' => '#ffffff',
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Mobile Menu Hamberger Color & Background', 'aabbe' ),
						),
						array(
							'id'      => 'mobile_menu_hamberger_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( ' Menu Hambarger Background', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu hamberger background color by color picker', 'aabbe' ),
							'default' => '#292929',
						),
						array(
							'id'      => 'mobile_sticky_menu_hamberger_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Sticky Menu Hambarger Background', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu hamberger color by color picker', 'aabbe' ),
							'default' => '#ff5e5e',
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Mobile Menu Border', 'aabbe' ),
						),
						array(
							'id'      => 'mobile_menu_border_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Menu Bottom Border Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the menu border bottom color by color picker', 'aabbe' ),
							'default' => 'rgba(255,255,255,.15)',
						),
					)
				),

				// sub section 1
				array(
					'name'   => 'logos',
					'title'  => esc_html__( 'Logo Upload', 'aabbe' ),
					'icon'   => 'fa fa-file-image-o',
					'fields' => array(
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Main Image Logo', 'aabbe' ),
						),
						array(
							'id'      => 'logo',
							'type'    => 'image',
							'title'   => esc_html__( 'Upload Main Logo', 'aabbe' ),
							'desc'    => esc_html__( 'Upload main logo width 180px and height 65px.', 'aabbe' ),
							'default' => '',
							'help'    => esc_html__( 'Note: Please use logo image max width: 250px and max height 100px.', 'aabbe' ),
						),
						array(
							'id'      => 'sticky_logo',
							'type'    => 'image',
							'title'   => esc_html__( 'Upload Sticky Logo', 'aabbe' ),
							'desc'    => esc_html__( 'Upload sticky logo width 180px and height 65px.', 'aabbe' ),
							'default' => '',
							'help'    => esc_html__( 'Note: Please use logo image max width: 250px and max height 100px.', 'aabbe' ),
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Text Logo Color', 'aabbe' ),
						),
						array(
							'id'      => 'logo_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Text Logo Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the text logo color by color picker.', 'aabbe' ),
							'default' => '#ffffff',
						),
						array(
							'id'      => 'sticky_logo_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Text Logo Sticky Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the text logo sticky color by color picker.', 'aabbe' ),
							'default' => '#333333',
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Mobile Text Logo Color', 'aabbe' ),
						),
						array(
							'id'      => 'mobile_logo_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Text Logo Color On Mobile', 'aabbe' ),
							'desc'    => esc_html__( 'Set the text logo color by color picker.', 'aabbe' ),
							'default' => '#333333',
						),
						array(
							'id'      => 'mobile_sticky_logo_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Text Logo Sticky Color On Mobile', 'aabbe' ),
							'desc'    => esc_html__( 'Set the text logo sticky color by color picker.', 'aabbe' ),
							'default' => '#ff5e5e',
						),
					)
				),

			    // sub section 3
			    array(
					'name'   => 'sub_header_3',
					'title'  => 'Favicon Icon',
					'icon'   => 'fa fa-image',
					'fields' => array(
						array(
							'id'    => 'favicon_icon',
							'type'  => 'image',
							'title' => 'Set the favicon icon size ( 16px x 16px ) OR ( 32px x 32px )',
						),
					),
				),

			),
		);
		
		/* BLOG PAGE */
		$options[]    = array(
		    'name'   => 'blog_page_section',
		    'title'  => 'Blog Setting',
		    'icon'   => 'fa fa-book',
		    'type'   => 'group',
		    'fields' => array(
				array(
				  'type'    => 'subheading',
				  'content' => esc_html__( 'Default Blog & Page Header Style', 'aabbe' ),
				),
		      	array(
					'id'      => 'blog_page_title',
					'type'    => 'text',
					'title'   => esc_html__( 'Blog Page Title', 'aabbe' ),
					'desc'    => esc_html__( 'Set the main blog page title here like ( Our Blog )', 'aabbe' ),
					'default' => 'Blog Page',
		    	),
		     	 array(
					'id'      => 'blog_page_barner',
					'type'    => 'image',
					'title'   => 'Blog Page Barner',
					'desc'    => 'Set the main blog page barner image size (1920px x 1280px ) or ( 1920px x 1080px )',
					'default' => '',
		    	),
				array(
					'id'      => 'blog_page_overlay',
					'type'    => 'background',
					'title'   => esc_html__( 'Blog Page Overlay', 'aabbe' ),
					'desc'    => esc_html__( 'Upload a transparent image or cholse your color t set the blog page header overlay', 'aabbe' ),
					'default' => array(
						'repeat'     => 'repeat',
						'position'   => 'center center',
						'attachment' => 'scroll',
						'size'       => '',
						'color'      => '#182044',
					),
				),
		      	array(
			        'id'      => 'blog_page_overlay_opacity',
			        'type'    => 'number',
			        'title'   => esc_html__( 'Blog Page Overlay Opacity', 'aabbe' ),
			        'desc'    => esc_html__( 'Set the main blog page overlay opacity max value is 90 in decimel', 'aabbe' ),
			        'default' => 50,
		    	),
				array(
				  'type'    => 'subheading',
				  'content' => esc_html__( 'Blog & Page Header Text Style', 'aabbe' ),
				),
		      	array(
			        'id'      => 'header_textcolor',
			        'type'    => 'color_picker',
			        'title'   => esc_html__( 'Header Text Color', 'aabbe' ),
			        'desc'    => esc_html__( 'Set the header text color by color picker. NOTE: You can also change header text color form customizer panel.', 'aabbe' ),
			        'default' => '#ffffff',
		    	),
		      	array(
			        'id'      => 'header_text_align',
			        'type'    => 'select',
			        'title'   => esc_html__( 'Header Text Align', 'aabbe' ),
			        'desc'    => esc_html__( 'Set the header text alignment ( Left / Roght / Center )', 'aabbe' ),
			        'options' => array(
						'left'   => 'Left',
						'center' => 'Center',
						'right'  => 'Right',
				  	),
					'default' => 'center',
		    	),
				array(
				  'type'    => 'subheading',
				  'content' => esc_html__( 'Blog & Page Default Options', 'aabbe' ),
				),
		      	array(
			        'id'      => 'blog_excerpt_word',
			        'type'    => 'number',
			        'title'   => esc_html__( 'Blog Excerpt Word', 'aabbe' ),
			        'desc'    => esc_html__( 'Set the words that how many words you want to show in every blog post item.', 'aabbe' ),
			        'default' => '20',
		    	),
			    array(
					'id'      => 'sticky_sidebar',
					'type'    => 'switcher',
					'title'   => esc_html__( 'Sticky Sidebar ?', 'aabbe' ),
					'desc'    => esc_html__( 'You can set sitcky blog page sidebar here. just set ( YES / NO ) for off OR on.', 'aabbe' ),
					'default' => true,
			    ),
			    array(
					'id'      => 'show_dropcaps',
					'type'    => 'switcher',
					'title'   => esc_html__( 'Show Dropcaps ?', 'aabbe' ),
					'desc'    => esc_html__( 'If you on dropcaps it will be appear in single blog page. just set ( YES / NO ) for off OR on.', 'aabbe' ),
					'default' => false,
			    ),
				array(
				  'type'    => 'subheading',
				  'content' => esc_html__( 'Blog & Page Content Area', 'aabbe' ),
				),
		      	array(
			        'id'      => 'content_spaceing',
			        'type'    => 'number',
			        'title'   => esc_html__( 'Blog & Pages Content Spaceing Top / Bottom', 'aabbe' ),
			        'desc'    => esc_html__( 'Set the space in blog and page content. It will be appeard in top and bottom.', 'aabbe' ),
			        'default' => '100',
		    	),
		    )
		);

    	/* SINGLE POST & PAGES */
	    $options[] = array(
			'name'   => 'single_post_and_page_section',
			'title'  => esc_html__( 'Post & Pages Settings', 'aabbe' ),
			'icon'   => 'fa fa-book',
			'fields' => array(
				array(
				  'type'    => 'subheading',
				  'content' => esc_html__( 'Single Post Setting', 'aabbe' ),
				),
				array(
					'id'      => 'enable_post_barner_title',
					'type'    => 'switcher',
					'title'   => esc_html__( 'Enable Post Custom Barner Title', 'aabbe' ),
					'desc'    => esc_html__( 'If you want to enable or disable post barner title to post title you can set ( YES / NO )', 'aabbe' ),
					'default' => false,
				),
				array(
					'id'         => 'custom_post_barner_title',
					'type'       => 'text',
					'title'      => esc_html__( 'Post Barner Title', 'aabbe' ),
					'desc'       => esc_html__( 'Set your preferred custom barner title.', 'aabbe' ),
					'default'    => esc_html__( 'News Details','aabbe' ),
					'dependency' => array( 'enable_post_barner_title', '==', 'true' ),
				),
				array(
					'id'      => 'enable_post_barner_top_meta',
					'type'    => 'switcher',
					'title'   => esc_html__( 'Enable Single Post Barner Top Meta', 'aabbe' ),
					'desc'    => esc_html__( 'If you want to enable or disable post barner top meta you can set ( YES / NO )', 'aabbe' ),
					'default' => false,
				),
				array(
					'id'      => 'enable_post_barner_bottom_meta',
					'type'    => 'switcher',
					'title'   => esc_html__( 'Enable Single Post Barner Bottom Meta', 'aabbe' ),
					'desc'    => esc_html__( 'If you want to enable or disable post barner bottom meta you can set ( YES / NO )', 'aabbe' ),
					'default' => false,
				),
				array(
				  'type'    => 'subheading',
				  'content' => esc_html__( 'Single Portfolio Setting', 'aabbe' ),
				),
				array(
					'id'      => 'enable_portfolio_barner_title',
					'type'    => 'switcher',
					'title'   => esc_html__( 'Enable Portfolio Custom Barner Title', 'aabbe' ),
					'desc'    => esc_html__( 'If you want to enable or disable portfolio barner title to portfolio title you can set ( YES / NO )', 'aabbe' ),
					'default' => false,
				),
				array(
					'id'         => 'custom_portfolio_barner_title',
					'type'       => 'text',
					'title'      => esc_html__( 'Portfolio Barner Title', 'aabbe' ),
					'desc'       => esc_html__( 'Set your preferred custom barner title.', 'aabbe' ),
					'default'    => esc_html__( 'Work Details','aabbe' ),
					'dependency' => array( 'enable_portfolio_barner_title', '==', 'true' ),
				),
				array(
				  'type'    => 'subheading',
				  'content' => esc_html__( '404 Error Page Setting', 'aabbe' ),
				),
				array(
					'id'      => 'error_page_img',
					'type'    => 'image',
					'title'   => esc_html__( 'Upload Error Page Image', 'aabbe' ),
					'desc'    => esc_html__( 'Upload error page image width 1280px and height 800px or larger.', 'aabbe' ),
				),
				array(
					'id'      => 'error_page_bg',
					'type'    => 'background',
					'title'   => esc_html__( '404 Page Background', 'aabbe' ),
					'desc'    => esc_html__( 'Upload a new background image or select color to set the error page background.', 'aabbe' ),
					'default' => array(
						'image'      => AABBE_ROOT_IMAGE . '/404-bg.png',
						'repeat'     => 'no-repeat',
						'position'   => 'left center',
						'attachment' => 'scroll',
						'size'       => '',
						'color'      => '#ffffff',
					),
				),
				array(
					'id'         => 'error_text',
					'type'       => 'text',
					'title'      => esc_html__( '404 Error Page Text', 'aabbe' ),
					'desc'       => esc_html__( 'Set your 404 error title.', 'aabbe' ),
					'default'    => esc_html__( 'Oops! That page can&rsquo;t be found.', 'aabbe' )
				),
				array(
					'id'      => 'enable_404_search_button',
					'type'    => 'switcher',
					'title'   => esc_html__( 'Enable 404 Search Button', 'aabbe' ),
					'desc'    => esc_html__( 'If you want to enable or disable 404 page button you can set ( YES / NO )', 'aabbe' ),
					'default' => true,
				),
			),
	    );

	    /* EDD PAGE SETTINGS */
		if (class_exists('Easy_Digital_Downloads')) {
		    $options[] = array(
				'name'   => 'edd_page_section',
				'title'  => esc_html__( 'Easy Digital Downloads', 'aabbe' ),
				'icon'   => 'fa fa-download',
				'fields' => array(
					array(
					  'type'    => 'subheading',
					  'content' => esc_html__( 'Product Setting', 'aabbe' ),
					),
					array(
						'id'      => 'product_grid_style',
						'type'    => 'select',
						'title'   => esc_html__( 'Product Grid Style', 'aabbe' ),
						'desc'    => esc_html__( 'Set the product grid style which you want.', 'aabbe' ),
						'options' => array(
							'product_grid_1' => esc_html__( 'Product Grid Style 1', 'aabbe' ),
							'product_grid_2' => esc_html__( 'Product Grid Style 2', 'aabbe' ),
						),
						'default' => 'product_grid_1',
					),
					array(
						'id'      => 'enable_product_buynow_title',
						'type'    => 'switcher',
						'title'   => esc_html__( 'Custom Buynow Title?', 'aabbe' ),
						'desc'    => esc_html__( 'If you want to set custom buy now title you can set ( YES / NO )', 'aabbe' ),
						'default' => false,
					),
					array(
						'id'         => 'product_buynow_title',
						'type'       => 'text',
						'title'      => esc_html__( 'Buynow Button Title', 'aabbe' ),
						'desc'       => esc_html__( 'Set your preferred custom buynow button title.', 'aabbe' ),
						'default'    => esc_html__( 'Purchase','aabbe' ),
						'dependency' => array( 'enable_product_buynow_title', '==', 'true' ),
					),
					array(
						'id'      => 'enable_product_preview_text',
						'type'    => 'switcher',
						'title'   => esc_html__( 'Custom Preview Title?', 'aabbe' ),
						'desc'    => esc_html__( 'If you want to set custom preview title you can set ( YES / NO )', 'aabbe' ),
						'default' => false,
					),
					array(
						'id'         => 'product_preview_text',
						'type'       => 'text',
						'title'      => esc_html__( 'Preview Button Title', 'aabbe' ),
						'desc'       => esc_html__( 'Set your preferred custom preview button title.', 'aabbe' ),
						'default'    => esc_html__( 'Live Preview','aabbe' ),
						'dependency' => array( 'enable_product_preview_text', '==', 'true' ),
					),
					array(
						'id'      => 'product_variable_pricing_options',
						'type'    => 'select',
						'title'   => esc_html__( 'Product Variable Price Option', 'aabbe' ),
						'desc'    => esc_html__( 'Set the product variable price opiton which you want.', 'aabbe' ),
						'options' => array(
							'default' => esc_html__( 'Default Style', 'aabbe' ),
							'custom'  => esc_html__( 'Custom Style', 'aabbe' ),
						),
						'default' => 'custom',
					),
					array(
					  'type'    => 'subheading',
					  'content' => esc_html__( 'Login Page Setting', 'aabbe' ),
					),
					array(
						'id'      => 'login_page_logo',
						'type'    => 'image',
						'title'   => esc_html__( 'Upload Login Page Logo', 'aabbe' ),
						'desc'    => esc_html__( 'Upload a login page logo max width ( 250px ).', 'aabbe' ),
					),
					array(
					  'type'    => 'subheading',
					  'content' => esc_html__( 'Email Template Setting', 'aabbe' ),
					),
					array(
						'id'      => 'accent_color',
						'type'    => 'color_picker',
						'title'   => esc_html__( 'Accent Color', 'aabbe' ),
						'desc'    => esc_html__( 'Set the email template accent color.', 'aabbe' ),
						'default' => '#ff5e5e'
					),
					array(
						'id'      => 'accent_color_text',
						'type'    => 'color_picker',
						'title'   => esc_html__( 'Accent Text Color', 'aabbe' ),
						'desc'    => esc_html__( 'Set the email template accent text color.', 'aabbe' ),
						'default' => '#ffffff'
					),
					array(
						'id'      => 'regular_text_color',
						'type'    => 'color_picker',
						'title'   => esc_html__( 'Text Color', 'aabbe' ),
						'desc'    => esc_html__( 'Set the email template text color.', 'aabbe' ),
						'default' => '#777777'
					),
					array(
					  'type'    => 'subheading',
					  'content' => esc_html__( 'Other Setting', 'aabbe' ),
					),
					array(
						'id'      => 'enable_custom_vendor_url',
						'type'    => 'switcher',
						'title'   => esc_html__( 'Redirect Author To Vendor Page Url?', 'aabbe' ),
						'desc'    => esc_html__( 'If you want to redirect default author page to vendor url you can set ( YES / NO )', 'aabbe' ),
						'default' => false,
					),
					array(
						'id'      => 'edd_show_variable_price_desc',
						'type'    => 'switcher',
						'title'   => esc_html__( 'Show Variable Price Desc?', 'aabbe' ),
						'desc'    => esc_html__( 'If you want to set variable price description you can set ( YES / NO )', 'aabbe' ),
						'default' => false,
					),
					array(
						'id'         => 'edd_variable_price_desc',
						'type'       => 'textarea',
						'title'      => esc_html__( 'Variable Price Desc', 'aabbe' ),
						'desc'       => esc_html__( 'Set your variable price description.', 'aabbe' ),
						'dependency' => array( 'edd_show_variable_price_desc', '==', 'true' ),
					),
				),
		    );
		}

		/* PRELOADER */
		$options[] = array(
		    'name'   => 'preloader_section',
		    'title'  => esc_html__( 'Preloader ON / OFF', 'aabbe' ),
		    'icon'   => 'fa fa-spinner',
		    'fields' => array(
				array(
				  'type'    => 'subheading',
				  'content' => esc_html__( 'Preloader Type', 'aabbe' ),
				),
				array(
					'id'      => 'enable_preloader',
					'type'    => 'switcher',
					'title'   => esc_html__( 'Enable Preloader', 'aabbe' ),
					'desc'    => esc_html__( 'If you want to enable or disable preloader you can set ( YES / NO )', 'aabbe' ),
					'default' => true,
				),
				array(
					'id'      => 'prloader_style',
					'type'    => 'image_select',
					'title'   => esc_html__( 'Select Preloader Style', 'aabbe' ),
					'desc'    => esc_html__( 'You can set specifc preloader style in every page form here.', 'aabbe' ),
					'options' => array(
						'style_6'  => AABBE_ROOT_IMAGE .'/loader/loader_spinner.svg',
						'style_9'  => AABBE_ROOT_IMAGE .'/loader/loeader_square.gif',
						'style_22' => AABBE_ROOT_IMAGE .'/loader/horizontal_loader_2.svg',
					),
					'default'    => 'style_22',
					'dependency' => array( 'enable_preloader', '==', 'true' ),
				),
				array(
				  'type'    => 'subheading',
				  'content' => esc_html__( 'Preloader Background & Color', 'aabbe' ),
				),
				array(
					'id'      => 'preloader_bg',
					'type'    => 'background',
					'title'   => esc_html__( 'Preloader Background', 'aabbe' ),
					'desc'    => esc_html__( 'Upload a new background image or select color to set the preloader background.', 'aabbe' ),
					'default' => array(
						'image'      => '',
						'repeat'     => 'repeat',
						'position'   => 'center center',
						'attachment' => 'scroll',
						'size'       => '',
						'color'      => '#ffffff',
					),
				),
				array(
					'id'      => 'preloader_text_color',
					'type'    => 'color_picker',
					'title'   => esc_html__( 'Preloader Text Color', 'aabbe' ),
					'desc'    => esc_html__( 'Set the preloader text color', 'aabbe' ),
					'default' => '#000000'
				),
		    ),
		);

		/* SCROLL TOP */
		$options[]    = array(
		    'name'   => 'scrolltotop_section',
		    'title'  => esc_html__( 'Scroll Top Button', 'aabbe' ),
		    'icon'   => 'fa fa-arrow-up',
		    'fields' => array(
				array(
					'id'      => 'enable_scroll_top',
					'type'    => 'switcher',
					'title'   => esc_html__( 'Enable Scroll Top', 'aabbe' ),
					'desc'    => esc_html__( 'If you want to enable or disable scroll to top button you can set ( YES / NO )', 'aabbe' ),
					'default' => true,
				),
				array(
					'id'      => 'scroll_top_eassing',
					'type'    => 'select',
					'title'   => esc_html__( 'Scroll Top Animation', 'aabbe' ),
					'desc'    => esc_html__( 'You can set specifc eassing animation style in every page form here.', 'aabbe' ),
					'options' => array(
						'easeInSine'       => 'easeInSine',
						'easeOutSine'      => 'easeOutSine',
						'easeInOutSine'    => 'easeInOutSine',
						'easeInQuad'       => 'easeInQuad',
						'easeOutQuad'      => 'easeOutQuad',
						'easeInOutQuad'    => 'easeInOutQuad',
						'easeInCubic'      => 'easeInCubic',
						'easeOutCubic'     => 'easeOutCubic',
						'easeInOutCubic'   => 'easeInOutCubic',
						'easeInQuart'      => 'easeInQuart',
						'easeOutQuart'     => 'easeOutQuart',
						'easeInOutQuart'   => 'easeInOutQuart',
						'easeInQuint'      => 'easeInQuint',
						'easeOutQuint'     => 'easeOutQuint',
						'easeInOutQuint'   => 'easeInOutQuint',
						'easeInExpo'       => 'easeInExpo',
						'easeOutExpo'      => 'easeOutExpo',
						'easeInOutExpo'    => 'easeInOutExpo',
						'easeInCirc'       => 'easeInCirc',
						'easeOutCirc'      => 'easeOutCirc',
						'easeInOutCirc'    => 'easeInOutCirc',
						'easeInBack'       => 'easeInBack',
						'easeOutBack'      => 'easeOutBack',
						'easeInOutBack'    => 'easeInOutBack',
						'easeInElastic'    => 'easeInElastic',
						'easeOutElastic'   => 'easeOutElastic',
						'easeInOutElastic' => 'easeInOutElastic',
						'easeInBounce'     => 'easeInBounce',
						'easeOutBounce'    => 'easeOutBounce',
						'easeInOutBounce'  => 'easeInOutBounce',
					),
					'dependency' => array( 'enable_scroll_top', '==', 'true' ),
					'default'    => 'easeOutExpo',
				),
		    ),
		);

		/* FOOTER */
		$options[]    = array(
		    'name'     => 'footer_section',
		    'title'    => esc_html__( 'Footer Section', 'aabbe' ),
		    'icon'     => 'fa fa-cog',
		    'sections' => array(

		    	// Start Section.
				array(
					'name'   => 'sub_footer_1',
					'title'  => esc_html__( 'Footer Color & Background', 'aabbe' ),
					'icon'   => 'fa fa-paint-brush',
					'fields' => array(
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Footer Settings', 'aabbe' ),
						),
						array(
							'id'      => 'add_footer_template',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Add Footer Template', 'aabbe' ),
							'desc'    => esc_html__( 'If you want to set Elementor template as footer template you can set ( YES / NO )', 'aabbe' ),
							'default' => false,
						),
						array(
							'id'      => 'footer_style',
							'type'    => 'select',
							'title'   => esc_html__( 'Select Footer Style', 'aabbe' ),
							'desc'    => esc_html__( 'You can chose and select footer type here..', 'aabbe' ),
							'options' => aabbe_get_post_array(),
							'dependency' => array( 'add_footer_template', '==', 'true' ),
						),
					    array(
							'id'      => 'hide_footer',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Hide Footer ?', 'aabbe' ),
							'desc'    => esc_html__( 'If you want do not show the footer you can set here by ( YES / NO ).', 'aabbe' ),
							'default' => false,
					    ),
					    array(
							'id'      => 'sticky_footer',
							'type'    => 'switcher',
							'title'   => esc_html__( 'Sticky Footer ?', 'aabbe' ),
							'desc'    => esc_html__( 'You can set footer sticky here. just set ( YES / NO ).', 'aabbe' ),
							'default' => false,
					    ),
						array(
							'id'      => 'footer_bg',
							'type'    => 'background',
							'title'   => esc_html__( 'Footer Background', 'aabbe' ),
							'desc'    => esc_html__( 'Upload a new background image to set the footer background.', 'aabbe' ),
							'default' => array(
								'image'      => '',
								'repeat'     => 'no-repeat',
								'position'   => 'center center',
								'attachment' => 'scroll',
								'size'       => 'cover',
								'color'      => '#182044',
							),
						),
						array(
							'id'      => 'footer_overlay',
							'type'    => 'background',
							'title'   => esc_html__( 'Footer Background Overlay', 'aabbe' ),
							'desc'    => esc_html__( 'Upload a transparent image or cholse your color t set the footer background overlay', 'aabbe' ),
							'default' => array(
								'image'      => '',
								'repeat'     => 'repeat',
								'position'   => 'center center',
								'attachment' => 'scroll',
								'size'       => '',
								'color'      => '#182044',
							),
						),
						array(
							'id'      => 'footer_overlay_opacity',
							'type'    => 'number',
							'title'   => esc_html__( 'Overlay Opacity', 'aabbe' ),
							'desc'    => esc_html__( 'Set the background footer background overlay opacity input the max value 90 in decimel.', 'aabbe' ),
							'default' => '50',
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Footer Text & Link Color', 'aabbe' ),
						),
						array(
							'id'      => 'text_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Footer Text Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set footer text color form here.', 'aabbe' ),
							'default' => '#c2d1e2',
						),
						array(
							'id'      => 'hidding_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Footer Hidding Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set footer footer hidding color form here.', 'aabbe' ),
							'default' => '#ffffff',
						),
						array(
							'id'      => 'a_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Footer links color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the footer area link color', 'aabbe' ),
							'default' => '#c2d1e2',
						),
						array(
							'id'      => 'a_hover',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Footer links Hover color', 'aabbe' ),
							'desc'    => esc_html__( 'Set the footer area link hover color', 'aabbe' ),
							'default' => '#ff5e5e',
						),
					),
				),
				// End Section.

				// Start Section.
				array(
					'name'   => 'sub_footer_2',
					'title'  => esc_html__( 'Footer Bottom Style', 'aabbe' ),
					'icon'   => 'fa fa-bars',
					'fields' => array(
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Footer Bottom Type', 'aabbe' ),
						),
						array(
							'id'      => 'footer_bottom_style',
							'type'    => 'image_select',
							'title'   => esc_html__( 'Select Footer Bottom Style', 'aabbe' ),
							'desc'    => esc_html__( 'You can chose and select footer bottom type here..', 'aabbe' ),
							'options' => array(
								'style_1' => AABBE_ROOT_IMAGE . '/footer/footer_1.png',
								'style_2' => AABBE_ROOT_IMAGE . '/footer/footer_2.png',
								'style_3' => AABBE_ROOT_IMAGE . '/footer/footer_3.png',
							),
							'default' => 'style_1',
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Footer Bottom Background & Border', 'aabbe' ),
						),
						array(
							'id'      => 'footer_bottom_bg',
							'type'    => 'background',
							'title'   => esc_html__( 'Footer Bottom Background', 'aabbe' ),
							'desc'    => esc_html__( 'Upload a new background image to set the footer bottom background.', 'aabbe' ),
							'default' => array(
								'image'      => '',
								'repeat'     => 'repeat',
								'position'   => 'center center',
								'attachment' => 'scroll',
								'size'       => '',
								'color'      => '#182044',
							),
						),
						array(
							'id'      => 'footer_bottom_border_height',
							'type'    => 'number',
							'title'   => esc_html__( 'Footer Bottom Border Height', 'aabbe' ),
							'desc'    => esc_html__( 'Set the footer bottome border height in decimel. ( default is 2 ) ', 'aabbe' ),
							'default' => '2',
						),
						array(
							'id'      => 'footer_bottom_border_color',
							'type'    => 'color_picker',
							'title'   => esc_html__( 'Footer Bottom Border Color', 'aabbe' ),
							'desc'    => esc_html__( 'Set footer bottom border color form here.', 'aabbe' ),
							'default' => '#182044',
						),
						array(
						  'type'    => 'subheading',
						  'content' => esc_html__( 'Footer Bottom Spaceing', 'aabbe' ),
						),
						array(
							'id'      => 'footer_bottom_padding',
							'type'    => 'number',
							'title'   => esc_html__( 'Footer Bottom Space', 'aabbe' ),
							'desc'    => esc_html__( 'Set the space ( top / bottom ) in footer bottom.', 'aabbe' ),
							'default' => '30',
						),
					),
				),
				// End Section.
				
				// Start Section.
				array(
					'name'   => 'sub_footer_3',
					'title'  => esc_html__( 'Footer Copyright', 'aabbe' ),
					'icon'   => 'fa fa-copyright',
					'fields' => array(
						array(
							'id'       => 'copyright_text',
							'type'     => 'wysiwyg',
							'title'    => esc_html__( 'Footer Copyright', 'aabbe' ),
							'desc'     => esc_html__( 'Set the footer copyright text','aabbe' ),
							'settings' => array(
							    'textarea_rows' => 10,
							    'tinymce'       => true,
							    'media_buttons' => false,
						  	),
						  	'default' => 'Copryright &copy; QuomodoTheme All Right Reserved.',
						),
					),
				),
				// End Section.
		    ),
		);	

		/* SOCIAL */
		$options[]    = array(
		    'name'   => 'social_section',
		    'title'  => esc_html__( 'Social Section', 'aabbe' ),
		    'icon'   => 'fa fa-share-alt',
		    'fields' => array(
				array(
					'id'           => 'social_bookmark',
					'type'         => 'group',
					'title'        => esc_html__( 'Add Social Bookmark', 'aabbe' ),
					'button_title' => esc_html__( 'Add New Bookmark', 'aabbe' ),
					'desc'         => esc_html__( 'Set the social bookmark icon and link here. Esay to use it just click the add icon button and search your social icon and set the url for the profile .', 'aabbe' ),
					'fields'       => array(
						array(
							'id'      => 'bookmark_icon',
							'type'    => 'icon',
							'title'   => esc_html__( 'Social Icon', 'aabbe' ),
							'desc'    => esc_html__( 'Set the social profile icon like ( facebook, twitter, linkedin, youtube ect. )', 'aabbe' ),
							'default' => 'fa fa-facebook'
					    ),
					    array(
							'id'      => 'bookmark_url',
							'type'    => 'text',
							'title'   => esc_html__( 'Profile Url', 'aabbe' ),
							'desc'    => esc_html__( 'Type the social profile url lik http://facebook.com/yourpage. also you can add (facebook, twitter, linkedin, youtube etc.)', 'aabbe' ),
							'default' => 'http://facebook.com/quomodosoft'
					    ),
				  	),
				),
			    array(
					'id'      => 'enable_footer_social',
					'type'    => 'switcher',
					'title'   => esc_html__( 'Enable Footer Social', 'aabbe' ),
					'desc'    => esc_html__( 'Set the footer social hide or not.', 'aabbe' ),
					'default' => false,
			    ),
			    array(
					'id'         => 'social_color',
					'type'       => 'color_picker',
					'title'      => esc_html__( 'Footer Social Color', 'aabbe' ),
					'desc'       => esc_html__( 'Set the footer social bookmark color from here.', 'aabbe' ),
					'default'    => '#ffffff',
					'dependency' => array( 'enable_footer_social', '==', 'true' ),
			    ),
			    array(
					'id'         => 'social_hover_color',
					'type'       => 'color_picker',
					'title'      => esc_html__( 'Footer Social Hover Color', 'aabbe' ),
					'desc'       => esc_html__( 'Set the footer social bookmark hover color from here.', 'aabbe' ),
					'default'    => '#ff5e5e',
					'dependency' => array( 'enable_footer_social', '==', 'true' ),
			    ),
		    ),
		);


    	/* CUSTOM CSS */
	    $options[] = array(
			'name'   => 'custom_css_section',
			'title'  => esc_html__( 'Custom Css', 'aabbe' ),
			'icon'   => 'fa fa-css3',
			'fields' => array(
				array(
					'id'    => 'custom_css',
					'type'  => 'textarea',
					'title' => esc_html__( 'Write Custom Css Here', 'aabbe' ),
					'desc'  => esc_html__( 'Write custom css here with css selector. this css will be applied in all pages and post.', 'aabbe' ),
				),
			),
	    );

		/* BACKUPS */
		$options[]    = array(
		    'name'   => 'backup_section',
		    'title'  => esc_html__( 'Backup Options', 'aabbe' ),
		    'icon'   => 'fa fa-share-square-o',
		    'fields' => array(
			    array(
					'id'    => 'backup_options',
					'type'  => 'backup',
					'title' => esc_html__( 'Backup Your All Options', 'aabbe' ),
					'desc'  => esc_html__( 'If you want to take backup your option you can backup here.', 'aabbe' ),
			    ),
		    ),
		);

	  	return $options;
	}
}

add_filter( 'cs_framework_options', 'aabbe_theme_option_panel' );