<?php
/**
 * The template for displaying search results pages
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/#search-result
 *
 * @Package Aabbe
 * @since 1.0.0
 */

get_header();

if ( is_active_sidebar( 'main-sidebar' ) ) {
    $aabbe_layout = 'col-md-8 blog__content__wrap';
}else{
    $aabbe_layout = 'col-md-10 col-md-offset-1 col-lg-10 col-lg-offset-1';
}
?>
<?php 
	if ( function_exists('aabbe_title') ) {
		aabbe_title();
	}
?>
<div class="content-area section-padding">
    <div class="container">
        <div class="row">

			<?php if ( 'download' === get_post_type() ) :?>

					<?php if ( have_posts() ) : ?>
						<div class="row download__grid">
						<?php while ( have_posts() ) : ?>
							<?php the_post(); ?>
							<div class="col-md-4 col-lg-4 col-sm-6 col-xs-12">
								<?php get_template_part( 'edd/content/content-download', get_post_format() ); ?>
							</div>
						<?php endwhile; ?>
						</div>
						
						<div class="row">
							<div class="col-md-12">
								<div class="post-pagination">					
									<?php aabbe_pagination(); ?>
								</div>
							</div>
						</div>

					<?php else : ?>
						
						<?php get_template_part( 'template-parts/content/content', 'none' ); ?>

					<?php endif; ?>

			<?php else: ?>

				<div class="<?php echo esc_attr( $aabbe_layout ); ?>">
					<?php if ( have_posts() ) : ?>

						<?php while ( have_posts() ) : ?>
							<?php the_post(); ?>
							<?php get_template_part( 'template-parts/content/content','search' ); ?>
						<?php endwhile; ?>
						
						<div class="page-pagination">					
							<?php aabbe_navigation(); ?>
						</div>

					<?php else : ?>
						
						<?php get_template_part( 'template-parts/content/content', 'none' ); ?>

					<?php endif; ?>
				</div>
				<?php get_sidebar(); ?>

			<?php endif; ?>

		</div>
	</div>
</div>
<?php
get_footer();