<?php
/**
 * The template for displaying all single posts
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/#single-post
 *
 * @Package Aabbe
 * @since 1.0.0
 */

get_header();

if ( is_active_sidebar( 'download' ) ) {
	$aabbe_single_post_layout = 'col-md-8 product__content__wrap';
}else{
	$aabbe_single_post_layout = 'col-md-10 col-md-offset-1';
}
?>
<?php 
    if (function_exists('aabbe_title')) {
        aabbe_title();
    }
?>
<div class="content-area section-padding">
    <div class="container">
        <div class="row">
			<div class="<?php echo esc_attr( $aabbe_single_post_layout ); ?>">
				<?php while ( have_posts() ) : the_post(); ?>
                                
                    <?php get_template_part( 'edd/content/content-download', get_post_format() ); ?>

                    <div class="row">
                        <div class="col-md-12">
                            <div class="download__item__details__section">
                                <div class="donloead__item__details__menu">
                                    <div class="single-download-nav-mobile">
                                        <ul class="single__download__tabs__nav nav nav-tabs">
                                            <li class="active">
                                                <a data-toggle="tab" href="#item__details">
                                                    <span class="product__tab__icon"><img src="<?php echo esc_url( AABBE_ROOT_URI . '/edd/img/details_icon_1.png' ) ?>" alt="<?php echo esc_attr__( 'Details', 'aabbe' ) ?>"></span>
                                                    <span class="details__title"><?php echo esc_html__( 'Overview', 'aabbe' ); ?></span>
                                                    <span class="details__subtitle"><?php echo esc_html__( 'Details', 'aabbe' ); ?></span>
                                                </a>
                                            </li>
                                            <li>
                                                <a data-toggle="tab" href="#item-comments">
                                                    <span class="product__tab__icon"><img src="<?php echo esc_url( AABBE_ROOT_URI . '/edd/img/details_icon_2.png' ) ?>" alt="<?php echo esc_attr__( 'Details', 'aabbe' ) ?>"></span>
                                                    <span class="details__title"><?php echo esc_html__( 'Comments', 'aabbe' ); ?></span>
                                                    <span class="details__subtitle"><?php echo esc_html__( 'Feedback', 'aabbe' ); ?></span>
                                                </a>
                                            </li>
                                            <?php if( class_exists( 'EDD_Reviews' ) ) : ?>
                                            <li>
                                                <a data-toggle="tab" href="#item-reviews">
                                                    <span class="product__tab__icon"><img src="<?php echo esc_url( AABBE_ROOT_URI . '/edd/img/details_icon_3.png' ) ?>" alt="<?php echo esc_attr__( 'Details', 'aabbe' ) ?>"></span>
                                                    <span class="details__title"><?php echo esc_html__( 'Reviews', 'aabbe' ); ?></span>
                                                    <span class="details__subtitle"><?php echo esc_html__( 'Rating', 'aabbe' ); ?></span>
                                                </a>
                                            </li>
                                            <?php endif; ?>
                                            <?php if ( function_exists( 'EDD_FES' ) ) : ?>
                                            <li>
                                                <a data-toggle="tab" href="#item-support">
                                                    <span class="product__tab__icon"><img src="<?php echo esc_url( AABBE_ROOT_URI . '/edd/img/details_icon_4.png' ) ?>" alt="<?php echo esc_attr__( 'Details', 'aabbe' ) ?>"></span>
                                                    <span class="details__title"><?php echo esc_html__( 'Support', 'aabbe' ); ?></span>
                                                    <span class="details__subtitle"><?php echo esc_html__( 'Contact', 'aabbe' ); ?></span>
                                                </a>
                                            </li>
                                            <?php endif; ?>
                                        </ul>
                                    </div>
                                </div>
                                <div class="donwload__item__details__content tab-content">
                                    <div id="item__details" class="single__item__details tab-pane active fade in">
                                        <?php
                                            the_content();
                                        ?>
                                    </div>
                                    <div id="item-comments" class="single__item__details tab-pane fade">
                                        <?php
                                            if ( comments_open() || get_comments_number() ) :
                                                comments_template();
                                            endif;
                                        ?>
                                    </div>
                                    <?php if ( class_exists( 'EDD_Reviews' ) ) : ?>
                                    <div id="item-reviews" class="single__item__details tab-pane fade">
                                            <?php
                                                global $post;
                                                $user    = wp_get_current_user();
                                                $user_id = ( isset( $user->ID ) ? (int) $user->ID : 0 );
                                            ?>
                                            <?php if ( ! edd_reviews()->is_review_status( 'disabled' ) ) :  ?>
                                            <div class="item__reviews__section">
                                                <div class="comments">
                                                    <div class="comments-wrap">
                                                        <?php
                                                            edd_get_template_part( 'reviews' );
                                                            if ( get_option( 'thread_comments' ) ) {
                                                                edd_get_template_part( 'reviews-reply' );
                                                            }
                                                        ?>
                                                    </div>
                                                </div>
                                            </div>
                                            <?php endif; ?>
                                    </div>
                                    <?php endif; ?>
                                    <?php if ( function_exists( 'EDD_FES' ) ) : ?>
                                    <div id="item-support" class="single__item__details tab-pane fade">
                                        <?php
                                            echo do_shortcode( '[fes_vendor_contact_form id="'.get_the_author_meta( 'ID' ).'"]' );
                                        ?>
                                    </div>
                                    <?php endif; ?>
                                </div>
                                <?php aabbe_related_download_query(); ?>
                            </div>
                        </div>
                    </div>

                    <!-- RELATED ITEMS -->
                    <div class="row">
                        <div class="col-md-12">
                            <?php aabbe_related_posts_query(); ?>
                        </div>
                    </div>
                    <!--  RELATED ITEMS END  -->
                    
                <?php endwhile; ?>
			</div>
            <?php get_sidebar('download'); ?>
        </div>
    </div>
</div>
<?php
get_footer();