<?php
	/*-------------------------------
	    MAIN MENU
	--------------------------------*/
	if ( !function_exists('aabbe_menu')) {
		function aabbe_menu(){
			// Page Meta Data
			$page_meta_array        = aabbe_metabox_value('_aabbe_page_metabox');
			$enable_header_styleing = isset( $page_meta_array['enable_header_styleing'] ) ? $page_meta_array['enable_header_styleing'] : false;

			$enable_topbar           = cs_get_option( 'enable_topbar', false );
			$phone_number            = cs_get_option( 'phone_number' );
			$email_address           = cs_get_option( 'email_address' );
			$enable_social           = cs_get_option( 'enable_social' );
			$enable_action           = cs_get_option( 'enable_action', false );
			$button_text             = cs_get_option( 'button_text' );
			$button_url              = cs_get_option( 'button_url' );
			$enable_search           = cs_get_option( 'enable_search', false );
			$enable_offcanvas        = cs_get_option( 'enable_offcanvas', false );
			$enable_cart_bubtton     = cs_get_option( 'enable_cart_bubtton', false );
			$enable_language_bubtton = cs_get_option( 'enable_language_bubtton', false );
			$show_minicart           = cs_get_option( 'show_minicart' );
			$enable_user_menu        = cs_get_option( 'enable_user_menu',false );

			$enable_header_category_search = isset( $page_meta_array['enable_header_category_search'] ) ? $page_meta_array['enable_header_category_search'] : false;

	        $menu_width = aabbe_any_data('menu_width','container container__full');
	        if ( is_page() && $enable_header_styleing == true ) {
	        	if ( !empty($page_meta_array['menu_width']) ) {
	        		$menu_width = $page_meta_array['menu_width'];
	        	}
	        }elseif ( $menu_width ) {
	        	$menu_width = $menu_width;
	        }
	    ?>
	    <div class="header-top-area">
	    	<?php
	    		$search_style = '';
	    		if ( $search_style ) {
	    			$search_style = $search_form_style;
	    		}else{
	    			$search_style = 'one';
	    		}
	    	?>
			<div class="search-form-control">
				<div id="search-form-<?php echo esc_attr( $search_style )?>" class="search-form-<?php echo esc_attr( $search_style )?>">					
	    			<?php aabbe_search_form(false,false); ?>
				</div>
                <div class="search-control-bg"></div>
    			<button class="search-mode-close"><i class="ti ti-close"></i></button>
			</div>

	        <?php if( $enable_topbar == true ) : ?>
	        <!-- TOP BAR -->
	        <div class="top-bar">
	            <div class="<?php echo esc_attr( $menu_width ); ?>">
	                <div class="row">
	                    <div class="col-md-6 col-xs-12 col-sm-8">
	                        <div class="top-left-contact">
	                            <?php if( !empty($phone_number) ): ?>
	                            <p><i class="ti ti-headphone-alt"></i> <?php echo esc_html( $phone_number ); ?></p>
	                            <?php endif; ?>
	                            <?php if( !empty($email_address) ): ?>
	                            <p><i class="ti ti-email"></i> <?php echo esc_html( $email_address ); ?></p>
	                            <?php endif; ?>
	                        </div>
	                    </div>
	                    <div class="col-md-6 col-xs-12 col-sm-4">
	                        <?php
		                        if( $enable_social == true ){
		                        	aabbe_social_links();
		                        }
	                        ?>
	                    </div>
	                </div>
	            </div>
	        </div>
	        <!-- TOP BAR END -->        
	        <?php endif; ?>
	        
	        <!-- MAINMENU AREA -->
	        <div class="mainmenu-area" id="mainmenu-area">
	            <div class="mainmenu-area-bg"></div>
	            <nav class="navbar">
	                <div class="<?php echo esc_attr( $menu_width ); ?>">
	                    <div class="row">
	                        <div class="col-md-12 flex-v-center">
	                            <div class="navbar-header">
	                                <?php aabbe_logo_with_sticky(); ?>
	                            </div>
	                            <svg class="ham hamRotate ham8" viewBox="0 0 100 100" width="60">
	                                <path class="line top" d="m 30,33 h 40 c 3.722839,0 7.5,3.126468 7.5,8.578427 0,5.451959 -2.727029,8.421573 -7.5,8.421573 h -20" />
	                                <path class="line middle" d="m 30,50 h 40" />
	                                <path class="line bottom" d="m 70,67 h -40 c 0,0 -7.5,-0.802118 -7.5,-8.365747 0,-7.563629 7.5,-8.634253 7.5,-8.634253 h 20" />
	                            </svg>
	                            <?php
	                            	if ( true == cs_get_option('enable_promo_menu',false) ) {
		                                wp_nav_menu( array(
											'theme_location'  => 'promo_menu',
											'menu_id'         => 'paromo-menu',
											'menu'            => 'ul',
											'menu_class'      => 'nav navbar-nav pull-right',
											'container'       => 'div',
											'container_class' => 'promotion__menu visible-lg',
											'container_id'    => 'promotionl-nav',
											'depth'           => 1,
		                                ) );
	                            	}
	                                wp_nav_menu( array(
										'theme_location'  => 'mainmenu',
										'menu_id'         => 'nav',
										'menu'            => 'ul',
										'menu_class'      => 'nav navbar-nav pull-right',
										'container'       => 'div',
										'container_class' => 'stellarnav',
										'container_id'    => 'main-nav',
										'fallback_cb'     => 'aabbe_menu_default_fallback',
										'walker'          => new aabbe_Nav_Menu_Walker(),
	                                ) );
	                            ?>

	                            <?php if( $enable_action == true || $enable_search == true || $enable_offcanvas == true || $enable_cart_bubtton == true ) : ?>  
	                            <div class="header-action hidden-sm hidden-xs">
									
									<?php if( $enable_cart_bubtton == true ) : ?>
	                            		<?php get_template_part( 'edd/cart/header-cart' ); ?>
	                            	<?php endif; ?>
							
									<?php if( $enable_user_menu == true ) : ?>
	                            	<div class="author__menu">
	                            		<?php if(is_user_logged_in()): ?>
										<?php echo get_avatar( get_current_user_id(), 50 ); ?>
	                            		<?php else: ?>
	                            		<?php echo get_avatar( get_the_author_meta( 'id' ), 50 ); ?>
	                            		<?php endif; ?>

                            			<?php

                        				   /**
                        					* Displays a navigation menu.
                        					*
                        					* @since 3.0.0
                        					*/
	                        				if (is_user_logged_in()) {
                        						if ( has_nav_menu( 'user_menu_after_login' ) ) {
		                        					$defaults = array(
														'theme_location'  => 'user_menu_after_login',
														'menu'            => 'ul',
														'container'       => 'div',
														'container_class' => 'author__menu__wrap',
														'container_id'    => 'author__menu__wrap',
														'menu_class'      => 'author__menu__list',
														'menu_id'         => 'author__menu__list',
														'depth'           => 1,
		                        					);
                        							wp_nav_menu( $defaults );
                        						}
	                        				}else{
	                        					if ( has_nav_menu( 'user_menu' ) ) {
		                        					$defaults = array(
														'theme_location'  => 'user_menu',
														'menu'            => 'ul',
														'container'       => 'div',
														'container_class' => 'author__menu__wrap',
														'container_id'    => 'author__menu__wrap',
														'menu_class'      => 'author__menu__list',
														'menu_id'         => 'author__menu__list',
														'depth'           => 1,
		                        					);
                        							wp_nav_menu( $defaults );
	                        					}
	                        				}
                            			?>
	                            	</div>
	                            	<?php endif; ?>

	                            	<?php if( !empty($button_text) && $enable_action == true ): ?>
	                                <a class="action-button" href="<?php echo esc_url( $button_url ); ?>"><?php echo esc_html( $button_text ); ?></a>
	                            	<?php endif; ?>
	                            	
	                            	<?php if( $enable_search == true ) : ?>
	                                <a href="#" class="search-button"><i class="ti ti-search"></i></a>
	                            	<?php endif; ?>

									<?php if( class_exists('GTranslate') && $enable_language_bubtton == true ) : ?>
		                            	<?php $data = get_option('GTranslate'); $look = $data['widget_look']; ?>
		                            	<div class="language-button">
											<?php if( 'flags' == $look ): ?>
											<div class="language__selector">
		                            			<img src="<?php echo esc_url( get_theme_file_uri( '/assets/img/flag.jpg' ));?>" alt="<?php echo bloginfo( 'name' );?>">
		                            		</div>	                           		
		                            		<div class="language__list"><?php echo do_shortcode('[gtranslate]'); ?></div>
											<?php elseif( 'popup' == $look ): ?>
		                            		<div class="language__popup_button" onclick="<?php echo esc_attr( 'openGTPopup(this)' ); ?>">
		                            			<img src="<?php echo esc_url( get_theme_file_uri( '/assets/img/flag.jpg' ));?>" alt="<?php echo bloginfo( 'name' );?>">
		                            		</div>
		                            		<div class="language__popup"><?php echo do_shortcode('[gtranslate]'); ?></div>
											<?php endif; ?>
		                            	</div>
	                            	<?php endif; ?>

	                            </div>
	                        	<?php endif; ?>
	                        </div>
	                    </div>
	                </div>
	            </nav>
	        </div>
	        <!-- END MAINMENU AREA END -->

			<?php if( true == $enable_header_category_search ) : ?>
	        <!-- CATEGORY SEARCBAR AREA -->
	        <div class="header-category-search hidden-sm hidden-xs">
	            <div class="no-padding container width100p">
	                <div class="no-margin row">
	                    <div class="no-padding col-md-12 col-xs-12">
							<?php
								$taxonomies = array('download_category');
						        $args       = array( 
						           'orderby'    =>'count',
						           'hide_empty' => true,
						           'parent'     => 0,
						        );
								$input_value  = ( isset($_GET['s']) ) ? $_GET['s']: null;
							?>
							<form id="header__search__form" class="header__search__form" method="GET" action="<?php echo esc_url(home_url('/')); ?>">
								<div class="row no-margin">
									<div class="col-md-2 no-padding">
										<div class="search__categories">
											<?php echo aabbe_get_terms_dropdown( $taxonomies, $args ); ?>
										</div>
									</div>
									<div class="col-md-8 no-padding">
										<input class="download__search__input" name="s" value="<?php echo esc_attr( $input_value ) ?>" type="search" placeholder="Type your keyword......">
						            	<input type="hidden" name="post_type" value="download">
									</div>
									<div class="col-md-2 no-padding">
										<button type="submit" class="header-search-submit"><i class="fa fa-search"></i> Search</button>
									</div>
								</div>
							</form>
	                    </div>
	                </div>
	            </div>
	        </div>
	        <!-- CATEGORY SEARCBAR AREA END -->
	    	<?php endif; ?>
	    </div>
	    <?php
		}
	}

	/*----------------------------
	    MENU FALBACK
	-----------------------------*/
	if (!function_exists('aabbe_menu_default_fallback')) {
	    function aabbe_menu_default_fallback() {
	    	if ( is_user_logged_in() ) {
	        ?>
	        <div id="main-nav" class="stellarnav">            
	            <ul id="nav" class="nav navbar-nav pull-right">
	                <li>
	                    <a href="<?php echo admin_url(); ?>nav-menus.php">
	                        <?php esc_html_e( 'Set Mainmenu Here...', 'aabbe' ); ?>
	                    </a>
	                </li>
	            </ul>
	        </div>
	        <?php
	    	}
	    }
	}
    if (function_exists('aabbe_menu')) {
        aabbe_menu();
    }
    ?>