<?php
	/**
	* Template Name: Vendor Archive
	*
	* Template for displaying vendors in a grid.
	*
	* @Package Aabbe
	* @since 1.0.0
	*/
	if ( ! defined( 'ABSPATH' ) ) {
	    exit; // Exit if accessed directly.
	}
	get_header();
?>
<?php 
	aabbe_title();
?>
<?php

	global $post;

	if (class_exists('EDD_Front_End_Submissions')) {
		if ( is_singular( 'download' ) ) {
			$author = fes_get_vendor();
		}else{
			$author = new WP_User( $post->post_author );
		}
	}else{
		$author = new WP_User( $post->post_author );
	}

	if ( ! $author ) {
		$author = get_current_user_id();
	}

	$term            = get_term_by( 'slug', get_query_var( 'term' ), get_query_var( 'taxonomy' ) );
	$author_download = get_the_author_meta( 'ID',$author->ID );
	$paged           = ( get_query_var( 'paged')) ? get_query_var( 'paged') : 1;
	$CatTerms        = ( isset( $term->slug ) ) ? $term->slug : null;
	$cat             = ( isset( $_GET['download_category'] ) ) ? $_GET['download_category'] : null;
	$search          = ( isset( $_GET['search'] ) ) ? $_GET['search'] : null;
?>
<?php
    if (! isset( $wp_query->query['orderby'] ) ) {
       
        $args = array(
			'order'             => 'DESC',
			'post_type'         => 'download',
			'posts_per_page'    => 9,
			'author'            => $author_download,
			'paged'             => $paged ,
			'download_category' => $cat,
			's'                 => $search,
        );

    }else{
        switch ($wp_query->query['orderby']) {
            case 'newness_asc':
                $args = array(
					'orderby'           => 'newness_asc',
					'order'             => 'ASC',
					'post_type'         => 'download',
					'download_category' => $cat,
					'author'            => $author_download,
					's'                 => $search,
					'paged'             => $paged
                );
            break;
            case 'newness_desc':
                $args = array(
					'orderby'           => 'newness_desc',
					'order'             => 'DESC',
					'post_type'         => 'download',
					'download_category' => $cat,
					'author'            => $author_download,
					's'                 => $search,
					'paged'             => $paged
                );
            break;
            case 'sales':
                $args = array(
					'meta_key'          =>'_edd_download_sales',
					'order'             => 'DESC',
					'orderby'           => 'meta_value_num',
					'download_category' => $cat,
					'post_type'         => 'download',
					'author'            => $author_download,
					's'                 => $search,
					'paged'             => $paged
                );
            break;
            case 'price_asc':
            $args = array(
				'meta_key'          => 'edd_price',
				'order'             => 'ASC',
				'orderby'           => 'meta_value_num',
				'download_category' => $cat,
				'post_type'         => 'download',
				'author'            => $author_download,
				's'                 => $search,
				'paged'             => $paged
            );
            break;            
            case 'price_desc':
            $args = array(
				'meta_key'          => 'edd_price',
				'order'             => 'DESC',
				'orderby'           => 'meta_value_num',
				'download_category' => $cat,
				'post_type'         => 'download',
				'author'            => $author_download,
				's'                 => $search,
				'paged'             => $paged
            );
            break;            
            case 'title_asc':
            $args = array(
				'orderby'           => 'title',
				'order'             => 'ASC',
				'download_category' => $cat,
				'post_type'         => 'download',
				'author'            => $author_download,
				's'                 => $search,
				'paged'             => $paged
            );
            break;            
            case 'title_desc':
            $args = array(
				'orderby'           => 'title',
				'order'             => 'DESC',
				'download_category' => $cat,
				'post_type'         => 'download',
				'author'            => $author_download,
				's'                 => $search,
				'paged'             => $paged
            );
            break;
        }
    }
    $temp     = $wp_query; $wp_query = null;
    $wp_query = new WP_Query(); $wp_query->query($args); 
?>

<div class="content-area section-padding">
	<div class="container">

    <?php if ( $wp_query->have_posts() ) :  ?>

    	<div class="row">
			<?php while ( $wp_query->have_posts() ) : ?>
				<?php $wp_query->the_post(); ?>
	    		<div class="col-md-4 col-sm-6 col-xs-12">
		    		<?php get_template_part( 'edd/content/content-download', get_post_format() );  ?>
	    		</div>
			<?php endwhile; ?>
    	</div>

		<div class="row">
			<div class="col-md-12">
				<div class="post-pagination">					
					<?php aabbe_pagination(); ?>
				</div>
			</div>
		</div>

	<?php else : ?>
		<div class="row">
			<div class="col-md-12 col-xs-12">
				<h3><?php esc_html_e( 'No Product Found', 'aabbe' ); ?></h3>				
			</div>
		</div>
    <?php endif; ?>

	</div>
</div>

<?php get_footer();